#include <stdio.h>
#include "dvm.h"
#include "dvm_msg.h"

extern  int 	_myuserid;
extern  int 	_myapplid; 
extern  int     _myvdcetaskid;	
extern 	int 	_cvmsockfd;
extern  VDCE_MSG_HEADER		_cvm_header;

extern	FILE	*jfp;
vdce_end(flag)
int flag;
{
	int	done = -1;
	int     cvm_sig = -1;
	char 	msg[1024], command[5], msg_data[1024], *recv_msg;
	VDCE_MSG_HEADER		msg_header;
	int	cvmsockfd;
	

if (flag == STDINOUT) {
	fprintf(stdout,"\n%d\n",done); /* send signal(-1) to cvm */
	fflush(stdout);
	fscanf(stdin,"%d",&cvm_sig);   /* get confirm from cvm to finish */

	/*
	 * waiting msg from cvm to exit process
        */
	while (cvm_sig != 0) {
		fprintf(stdout,"%d\n",done);   /* send signal(-1) to cvm */
		fflush(stdout);
		fscanf(stdin,"%d",&cvm_sig);   /* get confirm from cvm to finish */
	}
}

else {
	cvmsockfd = _cvmsockfd;

        sprintf(msg, "%s\n%d\n%d\n%d\n%d\n", Task_Completion, 
	3, _myuserid, _myapplid, _myvdcetaskid);
                        /*userid, applid, taskid*/
        sprintf(_cvm_header.length, "%d",strlen(msg)+HEADERSIZE);

#ifdef DEBUG
	fprintf(jfp, "msg = %s\n", msg);
	fflush(jfp);
#endif
        send_data_using_msg(cvmsockfd, _cvm_header, msg, strlen(msg));
	
	/*get confirm from cvm to finish */
#ifdef DEBUG
	fprintf(jfp,"VDCE_END:Waiting for Task_Completion message fromCVM\n");
	fflush(jfp);
#endif

        recv_data_using_msg(cvmsockfd, &msg_header, &recv_msg);
	decode_command(recv_msg, command, msg_data);
	if (!strncmp(command, Task_Completion, 4)) 
		cvm_sig =0;

	while (cvm_sig != 0) {
       	   send_data_using_msg(cvmsockfd, _cvm_header, msg,strlen(msg));
		/*get confirm from cvm to finish */
        	recv_data_using_msg(cvmsockfd, &msg_header, &recv_msg);
		decode_command(recv_msg, command, msg_data);
		if (!strncmp(command, Task_Completion, 4)) 
			cvm_sig =0;
	}
   }
#ifdef DEBUG
	fprintf(jfp,"VDCE_END:I am done=%d\n",cvm_sig);
	fflush(jfp);
#endif
#ifdef JAVA
	fclose(jfp);
#endif
}

/*
 * Support process abort request from a user
 * Added Jan 11 1998 by Ilkyun Ra
*/
vdce_stop(flag)
int flag;
{
	int	done = -1;
	int     cvm_sig = -1;
	char 	msg[1024], command[5], msg_data[1024], *recv_msg;
	VDCE_MSG_HEADER		msg_header;
	int	cvmsockfd;
	

if (flag == STDINOUT) {
	fprintf(stdout,"\n%d\n",done); /* send signal(-1) to cvm */
	fflush(stdout);
}
else {
	cvmsockfd = _cvmsockfd;

        sprintf(msg, "%s\n%d\n%d\n%d\n%d\n", Task_Killing_ACK, 
	3, _myuserid, _myapplid, _myvdcetaskid);
                        /*userid, applid, taskid*/
        sprintf(_cvm_header.length, "%d",strlen(msg)+HEADERSIZE);

#ifdef DEBUG
	fprintf(jfp, "msg = %s\n", msg);
	fflush(jfp);
#endif
        send_data_using_msg(cvmsockfd, _cvm_header, msg, strlen(msg));
	
#ifdef DEBUG
	fprintf(jfp,"VDCE_STOP:sending ACK of Task_stop to LCVM\n");
	fflush(jfp);
#endif
   }
#ifdef DEBUG
	fprintf(jfp,"VDCE_Stop:I am stopped by the LCVM\n");
	fflush(jfp);
#endif
#ifdef JAVA
	fclose(jfp);
#endif
}

vdce_error(flag)
int flag;
{
        int     done = -1;
        int     cvm_sig = -1;
        char    msg[1024], command[5], msg_data[1024], *recv_msg;
        VDCE_MSG_HEADER         msg_header;
        int     cvmsockfd;
 
 
if (flag == STDINOUT) {
        fprintf(stdout,"\n%d\n",done); /* send signal(-1) to cvm */
        fflush(stdout);
        fscanf(stdin,"%d",&cvm_sig);   /* get confirm from cvm to fini
sh */
 
        /*
         * waiting msg from cvm to exit process
        */
        while (cvm_sig != 0) {
                fprintf(stdout,"%d\n",done);   /* send signal(-1) to c
vm */
                fflush(stdout);
                fscanf(stdin,"%d",&cvm_sig);   /* get confirm from cvm
 to finish */
        }
}
 
else {
        cvmsockfd = _cvmsockfd;
 
       switch(flag){
       case 125 : 
        sprintf(msg, "%s\n%d\n%d\n%d\n%d\n", Socket_Connect_Error,
        3, _myuserid, _myapplid, _myvdcetaskid);
                        /*userid, applid, taskid*/
        sprintf(_cvm_header.length, "%d",strlen(msg)+HEADERSIZE);
 
#ifdef DEBUG
        fprintf(jfp, "msg = %s\n", msg);
        fflush(jfp);
#endif
        send_data_using_msg(cvmsockfd, _cvm_header, msg, strlen(msg));
#ifdef DEBUG
        fprintf(jfp,"VDCE_Error:i am not done\n");
        fflush(jfp);
#endif
#ifdef JAVA
        fclose(jfp);
#endif
	exit(0); 
	break;
        default : break;
        }
   }
}
 


