////////////////////////////////////////////////////////////////////
//
//		CLASS : ApplListWin 
//		===================
//     the window is used for showing an application list 
//
//     Last_Modified: On 8/5/98.
////////////////////////////////////////////////////////////////////

import java.awt.*;
import java.applet.*;
import java.io.*;
import java.net.*;
import java.util.*;

class ApplListWin extends Dialog {

	int status = 0; 	
	String applName = null;
	private List nameList   = null;
	private Frame pp;
	private boolean flag = false;

	public ApplListWin(Frame parent, String title, URL url) {
		super(parent, title, true);
		setLayout(new BorderLayout());
		pp = parent;
		Panel panel = new Panel();
		Label msg = new Label("Name List :");
		panel.add(msg);
		add("North", panel);
		panel = new Panel();
		panel.setLayout(new GridLayout(1, 3));
		panel.add(new Label("  "));
		nameList = new List(4, false);
		DataInputStream dis = null;
		String aline = null;

		try {
			dis = new DataInputStream(url.openStream());
		}
		catch (IOException e1) {
			System.out.println("ERROR in: open applListServ servlet stream");
		}
		flag = false;
		try {
			while ((aline = dis.readLine()) != null) {
				flag = true;
				nameList.addItem(aline);
			}
			dis.close();
		}
		catch (IOException e1) {
			System.out.println("ERROR: Read data from runAppServ servlet");
		}
		if (!flag) {
			msg.setText("No Application To Open.");
		}
		panel.add(nameList);
		panel.add(new Label("  "));
		add("Center", panel);
		panel = new Panel();
		panel.setLayout(new GridLayout(2, 1));
		panel.add(new Label("  "));
		Panel pp = new Panel();
		pp.add(new Button("  OK  "));
		pp.add(new Label("  "));
		pp.add(new Button("CANCEL"));
		panel.add(pp);
		add("South", panel);
		setResizable(true);
		resize(300, 300);
		pack();
		show(true);
	}
 
	public boolean action(Event evt, Object obj) {

		if (evt.target instanceof Button) {
			if ("  OK  ".equals(obj)) {
				if ((applName == null)&&(flag))
					new MessageDia(pp, "You didn't choose any application!", false);
				else {
					status = 1;
					dispose();
				}
			}
			if ("CANCEL".equals(obj)) {
				status = 2;
				dispose();
				return true;
			}
		}
		return false;
	}

	public boolean handleEvent(Event evt) {
		if (evt.id == Event.LIST_SELECT || evt.id == Event.LIST_DESELECT) {
			if (evt.target == nameList) {
				applName = nameList.getSelectedItem();
				return true;
			}
		}
		return super.handleEvent(evt);
	}
}
