////////////////////////////////////////////////////////////////////
//
//		CLASS : RunApp 
//		=================
//     A Thread for waiting for the response from servlet runAppServ.
//
//     Last_Modified: On 8/5/98.
////////////////////////////////////////////////////////////////////

import java.awt.*;
import java.applet.*;
import java.io.*;
import java.net.*;
import java.util.*;

class RunApp extends Thread{
	private DataInputStream dis = null;
	private RunWin win = null;
	private URL url = null;
	private String execurl = null;
	private vdceapp appl = null;
	private int totalTaskNum;
	private String ACS_addr = null;
	private String ACS_arg = null;
	private String AESServHost = null;
	private String AESPortNo = null;

//	public RunApp(vdceapp appl, int totalTaskNum, RunWin w, URL url, String execUrl) {
	public RunApp(vdceapp appl, int totalTaskNum, 
			RunWin w, String ACS_addr,
			String ACS_arg, String execUrl, 
			String AESServHost, String AESPortNo) {  
//Jan./8th, 98 ,  B.ye
		this.appl = appl;
		this.totalTaskNum = totalTaskNum;
//		this.url  = url;
		this.ACS_addr  = ACS_addr;
		this.ACS_arg   = ACS_arg;
		this.execurl  = execUrl;
		this.win  = w;
		this.AESServHost = AESServHost;
		this.AESPortNo = AESPortNo;
	}
  
	public void run() {
		String aline = null;
		System.out.println("in run() of RunApp Thread");
		System.out.println("RunApp : " + ACS_addr);
		System.out.println("RunApp : " + ACS_arg);
		String ACSproxy_addr = "http://" + AESServHost + ":"
			+ AESPortNo
			+ "/servlet/ACSproxy?ACS_addr="	+ ACS_addr
			+ ACS_arg;
		try {
			System.out.println("invokeCVM proxy:" + ACS_addr);
			url = new URL(ACSproxy_addr);
		}
		catch (MalformedURLException e1) {
			System.out.println("Error when creating CVM URL: " + e1);
		}

		boolean stop=false; // B.Ye , Jan./10th/98

		try {
//			dis = new DataInputStream(url.openStream()); 
			dis = new DataInputStream(url.openConnection().getInputStream());
		}
		catch (IOException e1) { 
			System.out.println("ERROR in: open ACSproxy servlet stream: " + e1);
		}

		try {
			while ((aline = dis.readLine()) != null) {
				System.out.println("msg from ACSproxy servlet: " + aline);
				if ( aline.equals("finished") || aline.equals("<P>finished") ) {
					break;
				}
				else if ( aline.equals("Failure") || aline.equals("<P>Failure") ) {
					win.prompt.setText("Process Failure has been DETECTED! ");
//					win.prompt.append("Process Failure has been DETECTED! ");
					win.repaint();
					dis.close();

					System.out.println("waiting 5 seconds");
					try {
						Thread.sleep(5000);
					}
					catch(InterruptedException e) {
					}

					System.out.println("invokeCVM proxy by Fault:" + ACS_addr);

					try {
						url = new URL(ACSproxy_addr);
						cur_t timeclass = new cur_t();
						long nowtime = timeclass.work();
						System.out.println("=======================================");
						System.out.println("failure catched at Server AES= "+ nowtime);
						System.out.println("=======================================");
					}
					catch (MalformedURLException e1) {
						System.out.println("Error when creating CVM URL: " + e1);
					}

					try {
						dis = new DataInputStream(url.openConnection().getInputStream());
					}
					catch (IOException e1) { 
						System.out.println("ERROR in: open ACSproxy servlet stream: " + e1);
					}
				}
				else if ( aline.startsWith("fault") ) {
					StringTokenizer st = new StringTokenizer(aline);
					String dummy = st.nextToken();
					String fault_task_name = st.nextToken();
					String fault_task_id = st.nextToken();
					String fault_hostname = st.nextToken();

					System.out.println("Fault Task Name : " + fault_task_name);
					System.out.println("Fault Task ID   : " + fault_task_id);
					System.out.println("Fault hostname  : " + fault_hostname);

					win.prompt.setText("Fault has been DETECTED");
					win.extra_message1.setText("Type of Fault : PROCESS FAULT");
					win.extra_message2.setText("Task Name     : " + fault_task_name);
					win.extra_message3.setText("Task Number   : " + fault_task_id);
					win.extra_message4.setText("Machine Name  : " + fault_hostname);

					win.repaint();
					dis.close();

					System.out.println("waiting 5 seconds");
					try {
						Thread.sleep(5000);
					}
					catch(InterruptedException e) {
					}

					System.out.println("invokeCVM proxy by Fault:" + ACS_addr);

					try {
						url = new URL(ACSproxy_addr);
						cur_t timeclass = new cur_t();
						long nowtime = timeclass.work();
						System.out.println("=======================================");
						System.out.println("failure catched at Server AES= "+ nowtime);
						System.out.println("=======================================");
					}
					catch (MalformedURLException e1) {
						System.out.println("Error when creating CVM URL: " + e1);
					}

					try {
						dis = new DataInputStream(url.openConnection().getInputStream());
					}
					catch (IOException e1) { 
						System.out.println("ERROR in: open ACSproxy servlet stream: " + e1);
					}
				}
				else if( (win != null) && (win.prompt != null) ) {
					win.prompt.setText(aline);
//					win.prompt.replaceRange(aline, 1, 5);
					win.repaint();
				}  // if
			}
			dis.close();
		}
		catch (IOException e1) { 
			System.out.println("ERROR: Read data from ACSproxy servlet:" + e1);
			System.out.println("message from ACSproxy: " + aline);
		}

		if (win != null) {
			if (win.prompt != null) {
				win.prompt.setText(" Current Application Is Done! ");
//				win.prompt.replaceRange(" Current Application Is Done! ", 1, 5);
			}
			else {
				System.out.println("Label is null");
			}
		}

		Date currDate = new Date();
		long currTime = currDate.getTime();
		long delta    = currTime - appl.startTime;
		execurl = execurl + "&totalTime=" + delta + "&totalTask=" + totalTaskNum;

		System.out.println("execTimeServ url=" + execurl);

		URL exeUrl = null;
		try {
			exeUrl = new URL(execurl);
		}
		catch (MalformedURLException e) {
		}
		try {
			dis = new DataInputStream(exeUrl.openStream()); 
		}
		catch (IOException e1) { 
			System.out.println("ERROR in: open execTimeServ servlet stream");
		}
    
		try {
			while ((aline = dis.readLine()) != null) {
				System.out.println("msg from execTimeServ servlet: " + aline);
			}
			dis.close();
		}
		catch (IOException e1) { 
			System.out.println("ERROR: Read data from execTimeServ servlet");
		}

		win.close.enable();
		win.repaint();

		appl.savemenu.enable();
		appl.run_appl.enable();
		appl.run = false;	// finished running
		if (appl.eTimevisualWin != null) {
			if (appl.eTimevisualWin.timevisual != null) {
				appl.eTimevisualWin.timevisual.die = true;	    
				appl.eTimevisualWin.timevisual.keeprun = false; 
			}
		}
		System.out.println("  the Application runs OK. \n");
	}

}

