import java.awt.*;
import java.applet.*;
import java.io.*;
import java.net.*;
import java.util.*;

////////////////////////////////////////////////////////////////////
//
//		CLASS : RunPrefDialog
//		=====================
// for specifying preference for running resource in current function module.
// about Event processing, there are some tips. see comments on Jan 25.
// Problems: paralell computing, multiselections of machtype, how to know
// the newest selection, (mark the newest in array of machTypes?) other easy
// way? and must design some data stru to store the all selections.
//
// Last_Modified: 8/5/98
//
////////////////////////////////////////////////////////////////////

class RunPrefDialog extends Dialog {

  boolean     sequential = true;
  String[]    machnum    = new String[10];	
		// machnum[i] is the machine number selected by user for 
		// machine type i, corresponing to machTypes[i] 
  boolean     OkorNot    = false;
  int         platForm   = 0;  // default is platforms[0]
  int         threadType = 0;  // default is threadTypes[0]
  int         Protocol   = 0;  // default is Protocols[0]
  int         qosvalue   = 0;  // default is Qos[0]
  int         domain     = 1;  // default is domains[1]
  int         cluster    = 1;  // default is clusters[?][1]

// following variables are all private.
  List platformList, threadList, protocolList;
  List machtype, qos, domainList, clusterList;
  Checkbox    seq, para;
  TextField   mnum;     // machine number;
// following should come from resource database.
  String[]    machTypes  = {"Solaris/Sparc", "AIX/rs6000", "Solaris/x86", "Linux/x86"};
  String[]    platForms  = {"P4", "socket", "MPI", "DSM", "NCS", "PVM"};
  String[]    threadTypes= {"None", "Pthread", "Quick Thread", "Cthread"};
  String[]    Protocols  = {"TCP/IP", "ATM"};
//  String[]    Qos	 = {"ft1", "ft2"};
  String[]    Qos	 = {"Qos1", "Qos2"};
  String[]    domains    = {"any", "SU", "RL"};
  String[][]  clusters   = { {"any"}, {"any", "ATM"}, {"any", "ATM", "CAT", "TOP", "NPAC"}, {"any", "PG1", "ATM"} };
  int	      lastItem   = -1;	// last selected machtype, just for parallel.
  int	      currItem   = -1;	// current selected machtype.
  boolean[]   mtselected = new boolean[10];

  public RunPrefDialog(Frame parent, Func module, String title) {

    super(parent, title, true);
    setLayout(new BorderLayout());

    sequential = module.sequential;
    platForm   = module.platForm;
    threadType = module.threadType;
    Protocol   = module.Protocol;
    qosvalue   = module.qosvalue;
    machnum    = module.machnum;
    domain     = module.domain;
    cluster    = module.cluster;

    for (int i = 0; i < machTypes.length; i ++)
	if (machnum[i] != null)
	    mtselected[i] = true;
    Panel panel = new Panel();
    panel.setLayout(new GridLayout(4, 4));
    panel.add(new Label(" "));
    panel.add(new Label(" "));
    panel.add(new Label(" "));
    panel.add(new Label(" "));
    panel.add(new Label(" "));
    panel.add(new Label(" "));
    panel.add(new Label(" "));
    panel.add(new Label(" "));
    panel.add(new Label("Computation"));
    panel.add(new Label(" Type : "));
    panel.add(new Label("Domain : "));
    panel.add(new Label("Cluster : "));
    CheckboxGroup cbg = new CheckboxGroup();	// radiobox for computing type
    if (sequential) {
        seq  = new Checkbox("Sequential", cbg, true);
        para = new Checkbox("Parallel", cbg, false);
     }
    else {
        seq  = new Checkbox("Sequential", cbg, false);
        para = new Checkbox("Parallel", cbg, true);
     }
    panel.add(seq);
    panel.add(para);
    domainList = new List(1, false);
    for ( int i = 0; i < domains.length; i ++)
	  domainList.addItem(domains[i]);
    domainList.select(domain);
    clusterList = new List(1, false);
    for (int i = 0; i < clusters[domain].length; i ++)
	 clusterList.addItem(clusters[domain][i]);
    clusterList.select(cluster); 
    panel.add(domainList);
    panel.add(clusterList);

    add("North", panel);

    panel = new Panel();
    panel.setLayout(new GridLayout(4, 3));

    panel.add(new Label("Comm Type: "));
    panel.add(new Label("Thread Type : "));
    panel.add(new Label("Comm Protocol : "));
    
    platformList = new List(2, false);	// single selection	
    for (int i = 0; i < platForms.length; i ++ )
         platformList.addItem(platForms[i]);
    platformList.select(platForm);
    panel.add(platformList);
    threadList = new List(2, false);	// single selection	
    for (int i = 0; i < threadTypes.length; i ++ )
         threadList.addItem(threadTypes[i]);
    threadList.select(threadType);
    panel.add(threadList);
    protocolList = new List(2, false);	// single selection	
    for (int i = 0; i < Protocols.length; i ++ )
         protocolList.addItem(Protocols[i]);
    protocolList.select(Protocol);
    panel.add(protocolList);

    panel.add(new Label("Platform(OS/Arch):"));
    panel.add(new Label("Machine Number: "));
//    panel.add(new Label("Fault Tolerance: "));
    panel.add(new Label("Qos: "));
 
    if (sequential)
        machtype = new List(1, false);	// depends on sequential's value 
    else
        machtype = new List(1, true);	// depends on sequential's value 
    for (int i = 0; i < machTypes.length; i ++ ) {
         machtype.addItem(machTypes[i]);
	 if (machnum[i] != null)
	    machtype.select(i);
     }
    panel.add(machtype);

    panel.add(mnum = new TextField("   1   ")); 

    qos = new List(1, false); 
    for (int i = 0; i < Qos.length; i ++ )
         qos.addItem(Qos[i]);
    qos.select(qosvalue);
    panel.add(qos);
    add("Center", panel);

    panel = new Panel();
    panel.add(new Button("  OK  "));
    panel.add(new Label("    "));
    panel.add(new Button("CANCEL"));
    add("South", panel);
    resize(400, 270);
    show(true);
  }
 
  public Insets insets() {
    return new Insets(10, 10, 10, 10);
  }

  private void deselectAll() {

    for (int i = 0; i < machTypes.length; i ++) { 
	 machtype.deselect(i);
	 mtselected[i] = false;
	 machnum[i] = null;
     }
    for (int i = 0; i < platForms.length; i ++) 
	 platformList.deselect(i);
    for (int i = 0; i < threadTypes.length; i ++) 
	 threadList.deselect(i);
    for (int i = 0; i < Protocols.length; i ++) 
	 protocolList.deselect(i);
    for (int i = 0; i < Qos.length; i ++) 
	 qos.deselect(i);

  }

  public boolean action(Event evt, Object obj) {

    boolean flag = false;
    if (evt.id == Event.MOUSE_MOVE)
	mnum.setEditable(true);
	
    if (sequential)
    if (para.getState()) {
        sequential = false;
	deselectAll();	
        machtype.setMultipleSelections(true);
        flag = true;
     }
    if (! sequential)
    if (seq.getState()) {
        sequential = true;
	deselectAll();	
        machtype.setMultipleSelections(false);
        flag = true;
     }

    if (evt.target instanceof Button) {
        if ("  OK  ".equals(obj)) {
	    OkorNot = true;
	    if (currItem != -1) {
		mtselected[currItem] = true;
	        machnum[currItem] = mnum.getText();
		mnum.setEditable(true);
	     }
	    for (int i = 0; i < machTypes.length; i ++)
		 if (! mtselected[i])
		     machnum[i] = null;
	    domain = domainList.getSelectedIndex();
	    cluster = clusterList.getSelectedIndex();
System.out.println("domain=" + domains[domain] + " cluster=" + clusters[domain][cluster]);
	 }

        if (("  OK  ".equals(obj))||("CANCEL".equals(obj))) {
//	     setVisible(false);
             hide();
	     flag = true;
         }
    }
    return flag;
  }

  public boolean handleEvent(Event evt) {

    if (evt.id == Event.MOUSE_MOVE)
	mnum.setEditable(true);

    if (evt.id == Event.LIST_SELECT || evt.id == Event.LIST_DESELECT) {
	
        if (evt.target == domainList) {
            domain = domainList.getSelectedIndex();
            if (domain != -1) {
                int count = clusterList.countItems();
                for (int i = count-1; i >= 0; i --)
                     clusterList.delItem(i);
                for (int i = 0; i < clusters[domain].length; i ++)
                     clusterList.addItem(clusters[domain][i]);
                clusterList.select(0);
	     }
	 }
        if (evt.target == platformList) {
	   platForm = platformList.getSelectedIndex(); 
	   return true;
	 }
        if (evt.target == threadList) {
	    threadType = threadList.getSelectedIndex();
	   return true;
	 }
        if (evt.target == protocolList) {
	    Protocol = protocolList.getSelectedIndex();
	   return true;
	 }
        if (evt.target == qos) {
	    qosvalue = qos.getSelectedIndex();
	   return true;
	 }
        if (evt.target == machtype) {
	    int[] names; 
	    names = machtype.getSelectedIndexes();
	    if (sequential) {
		if (names.length > 0)
		    currItem = names[0];
		else
		    currItem = -1;
		mnum.setText("  ");
		mnum.setEditable(true);
	     }
	    boolean sign = false;
            for (int i = 0; i < names.length; i ++) {
                 if (! mtselected[names[i]]) {
                     mtselected[names[i]] = true;
		     sign = true;
                     currItem = names[i];
                     break;
                  }
             }      // for i in names.length
            if (! sign)
                for (int i = 0; i < machTypes.length; i ++) {
                     if (mtselected[i]) {
                         int j = 0;
                         for (j = 0; j < names.length; j ++)
                              if (names[j] == i)
                                  break; 
                         if (j == names.length) {
                             if (names.length > 0)
                                 currItem = names[0];
                             else
                                 currItem = -1;
                             mtselected[i] = false;
 
                             break;     
                          } // if j==
		       }    // if (mtselected[i]) 
                   }  	    //  for i loop, last time selected.
	    if ((currItem != -1)&&(! sequential)) 
		if (evt.id == Event.LIST_SELECT) {
		if (lastItem != -1) {
	            machnum[lastItem] = mnum.getText();
		 }
		mnum.setEditable(true);
		if (machnum[currItem] == null)
		   mnum.setText("  ");
		else
		   mnum.setText(machnum[currItem]);
		mnum.setEditable(true);
		repaint();
		lastItem = currItem;
	     }
	   return true;
         } 
     }

    return super.handleEvent(evt);	
  }     // end of EventHandle()

}	// the end of class RunPrefDialog
