////////////////////////////////////////////////////////////////////
//
//		CLASS : StopApp 
//		=================
//     A Thread for waiting for the response from servlet stopAppServ.
//     parameters:
//		vdceapp appl   -- current application
//		StopAppWin win -- message window
//		URL  url       -- the URL of the servlet
//
//     Last_Modified: On 8/5/98.
////////////////////////////////////////////////////////////////////

import java.awt.*;
import java.applet.*;
import java.io.*;
import java.net.*;
import java.util.*;

class StopApp extends Thread {
  private DataInputStream dis = null;
  private StopAppWin win  = null;
  private URL url      = null;
  private vdceapp appl = null;

  public StopApp(vdceapp appl, StopAppWin w, URL url) {
	this.appl = appl;
	this.url  = url;
	this.win  = w;
   }
  
  public void run() {
    String aline;
    System.out.println("in run() of StopApp Thread");
    try {
	dis = new DataInputStream(url.openStream()); 
     } catch (IOException e1) { 
	 System.out.println("ERROR in: open stopAppServ servlet stream");
	}
    try {
         while ((aline = dis.readLine()) != null) {
             System.out.println("StopApp.run read signal: " + aline);
             if (aline.equals("stopped"))
                 break;
           }
         dis.close();
     } catch (IOException e1) { 
	 System.out.println("ERROR: Read data from stopAppServ servlet");
	}
    if (win != null) {
	if (win.prompt != null)
            win.prompt.setText(" Current Application Is Being Stopped... ");
	else
	    System.out.println("Label is null");
     }
    win.close.enable();
    win.repaint();
    appl.savemenu.enable();
    appl.run_appl.enable();
    appl.run = false;	// finished running
    if (appl.eTimevisualWin != null)
        try {	// wait a while for cvm to put module exec time to db
             Thread.sleep(3000);
         }   catch (InterruptedException e) { }
	appl.eTimevisualWin.timevisual.die = true;	// stop time thread
	appl.eTimevisualWin.timevisual.keeprun = false;	// total exec time in db 
    System.out.println("  the Application Is Stopped. \n");
  }
}

