////////////////////////////////////////////////////////////////////
//
//              CLASS : loadInfoWin
//              ===================
//     the window is used for showing load information of the machines.
//     in a specified cluster in a given domain.
//     since the resource table hasn't been changed, all the resource
//     are filled as constants.
////////////////////////////////////////////////////////////////////
 
import java.awt.*;
import java.applet.*;
import java.io.*;
import java.net.*;
import java.util.*;

class loadInfoWin extends Frame {
	private int vwWidth = 500, vwHeight = 400;
	private TextArea data;
	int pos = 0;
	private Button close, show;
	private List domainList, clusterList, machineList, machTypeList;
	private String[]   domains = {"SU", "RL"};
	private String[][] clusters = { {"ATM", "TOP", "NPAC"}};
	private String[]   types = {"Solaris/Sparc", "AIX/rs6000", "Solaris/x86"};
	private String[]   ostypes = {"Solaris", "AIX", "Solaris"};
	private String[]   archtypes = {"Sparc", "rs6000", "x86"};

/**  
  private String[][][][] machines = { { { {"all", "merlin", "guinevere", "arthur",
		"lancelot", "emerlin", "earthur", "eguinevere", "elancelot"}, 
		{"all", "morgana", "bors", "ettard", "ewaine", "emorgana", 
		 "ebors", "ebeowulf", "ebercilak"},
		{"all", "pc01", "pa02", "pc03"} },
	      { {"all", "catibm1", "catibm2", "catibm3", "catibm4"},
	  	{"all", "catsun1", "catsun2", "catsun3"},
	  	{"all", "cat1", "cat2", "cat3"} },
	      { {"all", "ibmtop1", "ibmtop2", "ibmtop3", "ibmtop4"},
	  	{"all", "kundry", "fasolt", "hunding", "ortrud", "elsa"},
	  	{"all", "toppc1", "toppc2"} },
	      { {"all", "npacibm1", "npacibm2", "npacibm3"},
	  	{"all", "npacsun1", "npacsun2", "npacsun3"},
	  	{"all", "npac1", "npac2", "npac3"} } },
	    { { {"all", "rm1-ibm1", "rm1-ibm2", "rm1-ibm3"},
		{"all", "rm1-solaris1", "rm1-solaris2", "rm1-solaris3"},
		{"all", "rm1-pc1", "rm1-pc2", "rm1-pc3", "rm1-pc4"} },
	      { {"all", "rm2-ibm1", "rm2-ibm2", "rm2-ibm3"},
		{"all", "rm2-solaris1", "rm2-solaris2", "rm2-solaris3"},
		{"all", "rm2-pc1", "rm2-pc2", "rm2-pc3", "rm2-pc4"} } }, 
	    { { {"all"}, 
		{"all", "columbia", "pg_solaris1", "pg_solaris2"},
	        {"all", "falcon", "kea"} },
	      { {"all", "merlin", "guinevere", "arthur",
                "lancelot", "emerlin", "earthur", "eguinevere", "elancelot"},
                {"all", "morgana", "bors", "ettard", "ewaine", "emorgana",
                 "ebors", "ebeowulf", "ebercilak"},
                {"all", "pc01", "pc02", "pc03"} } }
	   };
**/

	private int domain=0, cluster=0, machine=0, mach_type=0;
	private String urlstr;
	private DataInputStream datas = null;
	private loadThread loadthread = null;
	private vdceapp father = null;

	public loadInfoWin(vdceapp father, String urlstr) {
		super();
		this.urlstr = urlstr;
		this.father = father;
		setTitle("Load Information Window : ");
		setLayout(new BorderLayout());
		data = new TextArea("\n", 20, 76);
		Font newf = new Font("Courier", Font.PLAIN, 18);
		data.setFont(newf);
		add("North", data);
		data.setEditable(false);

		Panel p = new Panel();
		//p.setLayout(new GridLayout(1, 6));
		p.add(new Label("Domains"));
		domainList = new List(1, false);
		for ( int i = 0 ; i < domains.length ; i++ ) {
			domainList.addItem(domains[i]);
		}
		domainList.select(0); 
		p.add(domainList);

		p.add(new Label("Clusters"));
		clusterList = new List(1, false);
		for ( int i = 0 ; i < clusters[0].length ; i++ ) {
			clusterList.addItem(clusters[0][i]);
		}
		clusterList.select(0);
		p.add(clusterList);

		p.add(new Label("MachType"));
		machTypeList = new List(1, false);
		for ( int i = 0 ; i < types.length ; i++ ) {
			machTypeList.addItem(types[i]);
		}
		machTypeList.select(0);
		p.add(machTypeList);

/**
    p.add(new Label("Machines"));
    machineList = new List(1, true);
    for (int i = 0; i < machines[0][0][0].length; i ++)
	 machineList.addItem(machines[0][0][0][i]);
    machineList.select(0);
    p.add(machineList);
**/

		add("Center", p);

		p = new Panel();
		add("South", p);
		show  = new Button("LoadInfo");
		close = new Button("CLOSE");
		p.add(show);
		p.add(new Label("  "));
		p.add(close);
		resize(vwWidth, vwHeight);
		pack();
		show();
	}

	public boolean action(Event evt, Object obj) {

		int machineS[];
		int machine=-1;

		if (evt.target instanceof Button) {
			if ("CLOSE".equals(obj)) {
				if (loadthread != null) {
					loadthread.die = true;
				}
				dispose();
				father.loadinfoWin = null;
				return true;
			}

			if ("LoadInfo".equals(obj)) {
				domain  = domainList.getSelectedIndex();
				cluster = clusterList.getSelectedIndex();
				mach_type = machTypeList.getSelectedIndex();

				if (domain == -1) {
					domain  = 0;
					cluster = 0;
					mach_type = 0;
				}
				else if (cluster == -1) {
					cluster = 0;
					mach_type = 0;
				}
				else if (mach_type == -1) {
					mach_type = 0;
				}
				else  {
/**
					if (machineS.length == 0) {
						machine = 0;
					}
					else if (machineS[0] == 0) {
						machine = 0;
					}
**/
				}

				data.replaceText("  ", 0, pos);
				pos = 0;
				String aline = "\n";
				String machineStr = "";
				data.insertText(aline, pos);

/**
				if (machine == 0) {
					for (int i = 1; i < machines[domain][cluster][mach_type].length; i ++) {
						machineStr += machines[domain][cluster][mach_type][i];
						if (i <= (machines[domain][cluster][mach_type].length - 2)) {
							machineStr += "+";
						}
					}
					System.out.println("machines=" + machineStr + "&&");
				}
				else {
					for (int i = 0; i < machineS.length; i ++) { 
						machineStr += machines[domain][cluster][mach_type][machineS[i]];
						if (i <= (machineS.length - 2)) {
							machineStr += "+";
						}
					}
				}
**/
				String urlStr = urlstr + "&domain=" + domains[domain] 
					+ "&cluster=" + clusters[domain][cluster]  
					+ "&OS=" + ostypes[mach_type] + "&Arch=" + archtypes[mach_type];
//					+ "&machines=" + machineStr;
				System.out.println("loadInfo URL=" + urlStr + "%%");

				if (loadthread != null) {
					loadthread.die = true;
					loadthread = null;
				}

				loadthread = new loadThread(this, data, urlStr);
				new Thread(loadthread).start();
			}	
			return false;
		}
		return false;
	}

	public boolean handleEvent(Event evt) {
 
		if (evt.id == Event.LIST_SELECT || evt.id == Event.LIST_DESELECT) {
 
			if (evt.target == domainList) {
				domain = domainList.getSelectedIndex();
				if (domain != -1) {
					int count = clusterList.countItems();
					for (int i = count-1; i >= 0; i--) {
						clusterList.delItem(i);
					}
					for (int i = 0; i < clusters[domain].length; i++) {
						clusterList.addItem(clusters[domain][i]);
					}
					clusterList.select(0);
/**
					count = machineList.countItems();
					for (int i = count-1; i >= 0; i--) {
						machineList.delItem(i);
					}
					for (int i = 0; i < machines[domain][0][mach_type].length; i++) {
						machineList.addItem(machines[domain][0][mach_type][i]);
					}
					machineList.select(0);
**/
				}
			}

			if (evt.target == clusterList) {
				cluster = clusterList.getSelectedIndex();
				if (cluster != -1) {
/**
					int count = machineList.countItems();
					for (int i = count-1; i >= 0; i--) {
						machineList.delItem(i);
					}
					for (int i = 0; i < machines[domain][cluster][mach_type].length; i++) {
						machineList.addItem(machines[domain][cluster][mach_type][i]);
					}
					machineList.select(0);
**/
				}
			}

			if (evt.target == machTypeList) {
				mach_type = machTypeList.getSelectedIndex();
				if (mach_type != -1) {
/**
					int count = machineList.countItems();
					for (int i = count -1; i >= 0; i--) {
						machineList.delItem(i);
					}
					for (int i = 0; i < machines[domain][cluster][mach_type].length; i++) {
						machineList.addItem(machines[domain][cluster][mach_type][i]);
					}
					machineList.select(0);
**/
				}
			}
			return true;
		}
		return super.handleEvent(evt);
	}
}
