//--------Modified by : Baoqing Ye ----------
// Modifying History:
//==================
// 7th/April,1998
// Image loading for national map
// 30th/March,1998
//  Menu button for visualization : Radar Monitor
//
// 2nd/Jan.,1998
// Stop actions -- inform S-CVM to destroy running application
//-------------------------------------------

import java.awt.*;
import java.applet.*;
import java.io.*;
import java.net.*;
import java.util.*;

class vdceapp extends Frame {

  adl  currApplet;
// following arrays should be defined using a Maximum Number.
 
  Func funcs_head = null;	
  Func fins_head  = null;	
  Func fouts_head = null;	
  Func funcs;			
  Func fins;			
  Func fouts;			
  Date startDate = new Date();
  long startTime = 0;

  Func tmpf=null, dragged = null;
  int modules  = 1;		
  int finputs  = 1;		
  int foutputs = 1;		

  FileNmDialog      fnd = null;
  MessageDia   exitflag = null; // exit flag. Jan.21
  MessageDia   discard  = null; // discard flag. May.18 
  RunWin       runwin   = null; 
  StopAppWin   stopwin  = null; 
  ApplListWin  openapp  = null; 

  int tx, ty;			// for dragging.
  int  menudepth   = 0;
  char menutype    = 'x';	
  char menuStatus  = 'd';	
  boolean selected = false;	
  boolean finput   = false;	
  boolean foutput  = false;	
  boolean newappl  = false;     
  boolean outf     = false;	
  boolean dragging = false;	
  boolean addlink  = false;	
  boolean  rmlink  = false;	
  boolean delmodule= false;	
  boolean linkable = false;	
  boolean register = false;	
  boolean curChang = false;	
  boolean saved    = false;	
  boolean saveflag = false; 	
  boolean run      = false;	
  boolean neverrun = true;	
  int openOrnew = 0; 		
  int linkfrom = 0, linkto = 0, linkport = 0, currModu = 0;

  String JevServHost;		
  String ACSServHost;		
  String PortNo;		
  String ACSPortNo;		
  String DrepIP, DrepPort, DrepDBA; 	
  String userID, domain, uname;
  String applID   = null; 
  String applName = null;	
  boolean startup =true;	
  boolean clearimg=true;	
  Image   startupImg;		// 
  static int guiWidth=800, guiHeight=600;
  TimeVisualWin eTimevisualWin = null; 
  loadInfoWin   loadinfoWin = null;
  selectedInfoWin selectedinfowin = null;

  boolean civapp = false;   // B.Ye, may/5th/98, true-runnuig civapp, otherwise linear

  private vMenuItem open, newapp, saveAs, delete, exit;
  private Menu edit;
  vMenuItem savemenu, run_appl;

  public vdceapp(adl currapplet, String hostname, String ACShostname, 
		 String portno, String ACSportno, String DrepIP, 
		 String DrepPort, String DrepDBA, Image img, 
		 String userID, String uname, String domain) {

    super("VDCE Application Development");
    currApplet    = currapplet;
    startupImg    = img; 
    this.userID   = userID;
    this.uname    = uname;
    this.domain   = domain;
    this.DrepIP   = DrepIP;
    this.DrepPort = DrepPort;
    this.DrepDBA  = DrepDBA;
    JevServHost   = hostname;
    ACSServHost   = ACShostname;
    PortNo        = portno;
    ACSPortNo     = ACSportno;
    civapp 	  = false;   // B.Ye, May/7th/98
    setBackground(Color.lightGray);
    setForeground(Color.black); // Feb.4
    setLayout(new FlowLayout());
    resize(guiWidth, guiHeight);
    vdceGUI();
  }

  private void vdceGUI() {

    MenuBar mbar;
    boolean isNextDepth0;
    Menu menu;
    MenuComponent menuThing;
    Menu m[] = new Menu[9];	// depends on the organization of lib modules, 
    Canvas c;			// it should be improved later, Mar.28,97
    add(c = new Canvas());
    setMenuBar(mbar = new MenuBar());
    int i = 1;
    MenuItem temp;

    mbar.add(menu = new Menu("SYSTEM"));
      open = new vMenuItem("Open", i++);
      menu.add(open);
      newapp = new vMenuItem("New", i++);
      menu.add(newapp);
      savemenu = new vMenuItem("Save", i++);
      menu.add(savemenu);
      saveAs = new vMenuItem("Save As", i++);
      saveAs.disable();
      menu.add(saveAs);
      delete = new vMenuItem("Delete", i++);
      delete.disable();
      menu.add(delete);
      exit = new vMenuItem("Exit", i++);
      menu.add(exit);

    mbar.add(edit = new Menu("EDIT"));
      edit.add(new vMenuItem("Add Link", i++));
      edit.add(new vMenuItem("Remove Link", i++));
      edit.add(new vMenuItem("Delete Modu", i++));

    mbar.add(menu = new Menu("EXECUTE"));
      run_appl = new vMenuItem("Run App", i++);
      menu.add(run_appl);
      menu.add(new vMenuItem("Stop App", i++));

    mbar.add(menu = new Menu("VISUALIZE"));
      menu.add(new vMenuItem("Execution Time", i++));
      menu.add(new vMenuItem("Load Information", i++));
      menu.add(new vMenuItem("Selected Machines", i++));
      menu.add(new vMenuItem("CIV Monitor", i++)); // B.Ye

    mbar.add(menu = new Menu("FILEModule"));
      menu.add(new vMenuItem("InputFile", i++));
      menu.add(new vMenuItem("OutputFile", i++));

    String menuline = null;
    URL u = null;
    DataInputStream menudb = null;

    try {
       String str = "http://" + JevServHost + ":" + PortNo + "/lib/modules.txt";
       u = new URL(str);
       System.out.println("URL invoked:" + str);
    } catch (MalformedURLException e) {}
    try {
      menudb = new DataInputStream(u.openStream());
    } catch (IOException e) {}
    while ( (menuThing = getMenuThing(menudb) ) != null) {
      if ( menutype == 'm' && menudepth == 0 ) {
        mbar.add(m[menudepth] = (Menu)menuThing);
      } else if(menutype == 'm') {
        m[menudepth-1].add(m[menudepth] = (Menu)menuThing);
      } else if (menutype == 'i') {
	if (menuStatus == 'd')
	    ((vMenuItem)menuThing).disable();
        m[menudepth-1].add((vMenuItem)menuThing);
      }
    }
    pack();
    validate();
    resize(guiWidth, guiHeight);
    show();

  }

  public MenuComponent getMenuThing(DataInputStream menudb) {
    String menuline = null;
    try {
      if (( menuline = menudb.readLine()).charAt(0) == '*') 
         return null;
    } catch (IOException e) {}
    int depth = menuline.charAt(1)-'0';
    menutype  = menuline.charAt(0);
    menudepth = depth;
    int inputs  =  menuline.charAt(3)-'0';
    int outputs = menuline.charAt(5)-'0';
    menuStatus  = menuline.charAt(6);
    String name = menuline.substring(7);
    if (menutype == 'i')
       return (new vMenuItem(name, depth, inputs, outputs));
    else 
       return (new Menu(name)) ;
  }

/* ************************************************************************* *
 *  			 private save() for Save menu.
 * CONVENTION : we use socket port number : 4444
 * ************************************************************************* */

  private void save() {

    URL u1 = null;
    DataInputStream infile  = null;
    OutputStream    Outfile = null;
    PrintStream     outfile = null;
    String aline;

    System.out.println("Current Application name: " + applName);
    System.out.println("The output from saveAppServ servlet: \n");
    try {
       String str = "http://" + JevServHost + ":" + PortNo + "/servlet/saveAppServ";

// Oct. 10, for multi-domain supporting. add domain rep parameters
       str = str + "?DrepIP=" + DrepIP + "&DrepPort=" + DrepPort
	     + "&DrepDBA=" + DrepDBA;

       System.out.println("url : " + str);

       u1 = new URL(str);

    } catch (MalformedURLException e1) {}
    try {
      infile = new DataInputStream(u1.openStream());
    } catch (IOException e1) {}
    int i=0;
    try {
        while ((aline = infile.readLine()) != null) {
              i ++;
              if ( i == 2)
                   break;
              System.out.println(aline);
         }
        infile.close();
        } catch (IOException e1) {}
 
    System.out.println("\nCreating client socket\n");
    Socket csock = null;
    InetAddress addr = null;
    try {
        addr = InetAddress.getByName(JevServHost);
    }   catch (UnknownHostException e1) { System.out.println("HOST error"); }
    int socketno;
    String param = currApplet.getParameter("AFTsocketNo");
    System.out.println("socke no : " + param);
        if (param == null)
            socketno = 5678;
        else
            socketno = Integer.parseInt(param);
    System.out.println("addr=" + addr.toString() + "  port=" + socketno + "##");
    boolean connected = false;
    int trial = 0;
    while (!connected) {
        try {
            csock = new Socket(addr, socketno);
            connected = true;
        }
        catch (IOException e1) {
            System.out.println("trying to create csocket");
            trial++;
        }
    }
    System.out.println("connected : trial " + trial);
    System.out.println("  created the client socket." + csock.toString());
 
    System.out.println("be going to write to the socket");
 
    try {
        Outfile = csock.getOutputStream();
        outfile = new PrintStream(Outfile);
    }   catch (IOException e1) { System.out.println("getOutputStream ERROR"); }
    System.out.println("NOW, writing\n");

// the status, no one needs to know except ADL.
// FilePath should be related to userName or UserID, file hierarchy !!! could be
// as a parameter from the dynamic HTML generated by authentication.

    String status = "d";	// just for testing,
    String str = currApplet.getParameter("FilePath"); 
    if (str == null)
        str = "/merlin2/users/vdce";
    str = str + "/demo/bin/";

    outfile.println(userID);	
    String astatement;		
    int j, k, l, outs;

    astatement = "DELETE FROM ApplInfo WHERE UserID='" + userID + "' AND ApplID ='"
		 + applID + "'";	// June 15,1997
    System.out.println("S=" + astatement);
    outfile.println(astatement);
    String pre = "INSERT INTO ApplInfo VALUES ('" +  userID + "', '" + applID 
		 + "', '" + applName;

    funcs = funcs_head;
    i = 0;
    while (funcs != null) {
	i ++;
	funcs = funcs.next;
     }
    astatement = pre + "', " + i;
    fins = fins_head;
    i = 0;
    while ( fins != null) {
	i ++;
	fins = fins.next;
     }
    astatement = astatement + ", " + i;

    fouts = fouts_head;
    i = 0;
    while ( fouts != null) {
	i ++;
	fouts = fouts.next;
     }
    astatement = astatement + ", " + i + ", '" + status + "')";
    System.out.println("S=" + astatement);
    outfile.println(astatement);

    astatement = "DELETE FROM AFT_" + userID + " WHERE ApplID ='" + applID + "'";
    System.out.println("S=" + astatement);
    outfile.println(astatement);
    astatement = "DELETE FROM Port_" + userID + " WHERE ApplID ='" + applID + "'";
    System.out.println("S=" + astatement);
    outfile.println(astatement);

    funcs = funcs_head;
    while (funcs != null) {	// AFT_userID table
	astatement = "INSERT INTO AFT_" + userID + " VALUES ('" + applID
		     + "', " + funcs.id + ", '" + funcs.name + "', 'c'";
	if (funcs.sequential)
	    astatement = astatement + ", 's', '";
	else
	    astatement = astatement + ", 'p', '";
	astatement += funcs.platForm + "', '" + funcs.threadType + "', '" 
		+ funcs.Protocol + "', '" + funcs.qosvalue + "', '";
	String mhtype = null, mhnum = null;   
        for (i = 0; i < funcs.machTypes.length; i ++) {
	     if (funcs.machnum[i] != null) { 
		 int number = 0;
		 try {
		    number = Integer.parseInt(funcs.machnum[i].trim());
		  } catch (NumberFormatException e) {
			funcs.machnum[i] = "1";	
		  }
		 if (mhtype == null) {
		     mhtype = funcs.machTypes[i] + "|";
		     mhnum  = funcs.machnum[i] + "|";
		  } else {	
		     mhtype += funcs.machTypes[i] + "|";
		     mhnum  += funcs.machnum[i] + "|";
		  }
	       }
	  }
	if (mhtype == null) {
	     mhtype = funcs.machTypes[0] + "|";
	     mhnum  = " 1|";
	 }	
	astatement += mhtype + "', '" + mhnum + "', " + funcs.x + ", " + funcs.y ;
// add two more fields "domain" and "cluster", Aug.31
	astatement += ", '" + funcs.domain + "', '" + funcs.cluster + "')";
    	System.out.println("S=" + astatement);
	outfile.println(astatement);

        for (i = 1 ; i <= funcs.inputs; i ++)  {
	     astatement = "INSERT INTO Port_" + userID + " VALUES ('" + applID
		     + "', " + funcs.id + ", 'i', " + i + ", ";
             if (funcs.ilinks[i][0] < 0) {
		 fins = fins_head;
		 while (fins != null) {
			if (fins.id == (-1)*funcs.ilinks[i][0])
			    break;
			fins = fins.next;
		  }	// from input file module
		 astatement += "'0', 0, 1, '" + fins.abbrev 
			+ "', '" + str + "')"; 
              }
             else {
		 astatement += "'7', " + funcs.ilinks[i][0] + ", " +  
			funcs.ilinks[i][1] + ", '??', '')"; 
              }
    	System.out.println("S=" + astatement);
	outfile.println(astatement);
         }

        outs = 0;

         for (j = 1; j <= funcs.outputs; j ++) {
              boolean outflag = false;
	      Func funcst = funcs_head;
	      while (funcst != null) {
         	for (l = 1; l <= funcst.inputs; l ++)
                     if ((funcst.ilinks[l][0] == funcs.id) && 
			 (funcst.ilinks[l][1] == j)) {
                        outflag = true;
	      		astatement = "INSERT INTO Port_" + userID + " VALUES ('" 
				+ applID + "', " + funcs.id + ", 'o', ";
			astatement += j + ", '7', " + funcst.id + ", " + l 
					+ ", '??', '')";
    			System.out.println("S=" + astatement);
			outfile.println(astatement);
                      }	// if
		funcst = funcst.next;
	       }
	      fouts = fouts_head;
	      while (fouts != null) {
              	if ((fouts.ilinks[1][0] == funcs.id) && 
		    (fouts.ilinks[1][1] == j)) {
                     outflag = true;
	      	     astatement = "INSERT INTO Port_" + userID + " VALUES ('" 
				+ applID + "', " + funcs.id + ", 'o', ";
		     astatement += j + ", '0', 0, 1, '" + fouts.abbrev + 
				"', '" + str + "')";
    		     System.out.println("S=" + astatement);
		     outfile.println(astatement);
                 }
	 	fouts = fouts.next;
	       }
              if (! outflag) {	
	      	  astatement = "INSERT INTO Port_" + userID + " VALUES ('" 
				+ applID + "', " + funcs.id + ", 'o', ";
		  astatement += j + ", 'n', 0, 0, '', '')"; 
    		  System.out.println("S=" + astatement);
		  outfile.println(astatement);
               }
           }	
	funcs = funcs.next; 
     }	
    
    fins = fins_head;
    while (fins != null) {
	astatement = "INSERT INTO AFT_" + userID + " VALUES ('" + applID
		   + "', " + fins.id + ", '" + fins.abbrev + "', 'i', " 
		   + "'', '', '', '', '', '', '', " + fins.x + ", "
		   + fins.y + ", ' ', ' ')";
	System.out.println("inputF=" + astatement);
	outfile.println(astatement);
	fins = fins.next;
     }
    fouts = fouts_head;
    while (fouts != null) {
        astatement = "INSERT INTO AFT_" + userID + " VALUES ('" + applID
                   + "', " + fouts.id + ", '" + fouts.abbrev + "', 'o', "
                   + "'', '', '', '', '', '', '', " + fouts.x + ", "
                   + fouts.y + ", ' ', ' ')";
        System.out.println("outputF=" + astatement);
        outfile.println(astatement);
        fouts = fouts.next;
     }
 
    outfile.close();
    try {
       csock.close();
       System.out.println("DONE");
     } catch (IOException e1) {
       System.out.println("close socket ERROR"); }
 
  }  // End of save().
 
/* ************************************************************************* *
 *                       private open_appl() for Open Appl menu.
 * ************************************************************************* */

  private void open_appl() {

    URL url = null;
    DataInputStream dis = null;
    String aline;
 
    System.out.println("\n  Request servlet applListServ to get the application list...\n");
 
    try {
       String str = "http://" + JevServHost + ":" + PortNo
                  + "/servlet/applListServ?userID=" + userID;
       str = str + "&DrepIP=" + DrepIP + "&DrepPort=" + DrepPort
	     + "&DrepDBA=" + DrepDBA;
       url = new URL(str);
     } catch (MalformedURLException e1) {}
    openapp = new ApplListWin(this, "Open Application Dialog", url);
  }
 
/* ************************************************************************* *
 *                       private load_appl() for Open Appl menu.
 * 	load data from the output of servlet loadApplServ and put them 
 * 	in the approprite data structure.
 * ************************************************************************* */

  private void load_appl() {

    URL url = null;
    DataInputStream dis = null;
    String aline;
 
    System.out.println("\n  Request servlet loadApplServ to get the application data...\n")
;
 
    try {
       String str = "http://" + JevServHost + ":" + PortNo
                  + "/servlet/loadApplServ?userID=" + userID + "&applName=" + applName;

       str = str + "&DrepIP=" + DrepIP + "&DrepPort=" + DrepPort
	     + "&DrepDBA=" + DrepDBA;

       url = new URL(str);
     } catch (MalformedURLException e1) {
         System.out.println("ERROR in: invoking loadApplServ servlet");
        }
    try {
        dis = new DataInputStream(url.openStream());
     } catch (IOException e1) {
         System.out.println("ERROR in: open loadApplServ servlet stream");
        }
    Func tmp = null;
    String taskNo = null;
    int task_no;
    modules = 0;
    try {
	 applID = dis.readLine();
	 String state = dis.readLine();

	 System.out.println("applID=" + applID + "&&");
         while ((aline = dis.readLine()) != null) {
		if (aline.equals("PORT"))
		    break;
		taskNo     = dis.readLine(); 	// TaskNo
		task_no    = Integer.parseInt(taskNo);
		if (task_no > modules)
		    modules = task_no;		// not total task num, it is for
						// assign new task unique task_no.
		aline      = dis.readLine();   	// ModuleID
		tmp        = new Func(aline, 100, 100, 0, 0);
		tmp.next   = funcs_head;
		tmp.abbrev = null;
		tmp.id     = task_no;
		aline 	   = dis.readLine();	// ModuleType
		aline 	   = dis.readLine();	// computation type
		if (aline.equals("p")) 
		    tmp.sequential = false;
		else
		    tmp.sequential = true;
		aline 	       = dis.readLine();	// communication type
		tmp.platForm   = Integer.parseInt(aline);
		aline 	       = dis.readLine();	// thread type
		tmp.threadType = Integer.parseInt(aline);
		aline 	       = dis.readLine();	// comm protocol type
		tmp.Protocol   = Integer.parseInt(aline);
		aline 	       = dis.readLine();	// qos type
		tmp.qosvalue   = Integer.parseInt(aline);
		String machs   = dis.readLine(); 	// machine type
		aline = dis.readLine();			// machine numbers
                System.out.println("machine num from loadServ: " + aline); // B.Ye
		String astr, nstr;
		int index, nindex, mach_index = 0;
		int startIndex = 0, nstartIndex = 0;
		while (true) {
		    index = machs.indexOf("|", startIndex);
		    if (index == -1)
			break;
		    astr = machs.substring(startIndex, index);
		    startIndex = index + 1;
		    for (int i = 0; i < tmp.machTypes.length; i ++) {
			if (astr.equals(tmp.machTypes[i])) {
			    mach_index = i;
			    break;
			 }
		     }
		    nindex = aline.indexOf("|", nstartIndex);
		    nstr   = aline.substring(nstartIndex, nindex);
		    tmp.machnum[mach_index] = nstr;
                    System.out.println("tmp.machnum:" + tmp.machnum[mach_index]);
                    // B.Ye, March'8th
		    nstartIndex = nindex + 1;
		  }
		aline = dis.readLine();
		tmp.x = Integer.parseInt(aline);
		aline = dis.readLine();
		tmp.y = Integer.parseInt(aline);
// Aug.31 for domain and cluster information
		aline 	       = dis.readLine();	// domain index 
		tmp.domain     = Integer.parseInt(aline);
		aline 	       = dis.readLine();	// cluster index 
		tmp.cluster    = Integer.parseInt(aline);
// The end of Aug. 31		
		funcs_head = tmp;
                System.out.println("funcs_head.machnum[index]=" + funcs_head.machnum[mach_index] ); // B.Ye
           }
	 String portType, commStatus, fileName, location;
	 int    portNo, linkTaskNo, linkPortNo;
         while ((aline = dis.readLine()) != null) {
		if (aline.equals("IFILE"))
		    break;
		taskNo = dis.readLine();
		task_no = Integer.parseInt(taskNo);
		tmp = funcs_head;
		while ( tmp != null) {
			if (tmp.id == task_no) 
			   break;
			tmp = tmp.next;
		  }	
		portType   = dis.readLine();
		aline      = dis.readLine();
		portNo     = Integer.parseInt(aline);
		commStatus = dis.readLine(); 
		aline      = dis.readLine();
		linkTaskNo = Integer.parseInt(aline); 
		aline      = dis.readLine();
		linkPortNo = Integer.parseInt(aline); 
		fileName   = dis.readLine();
		location   = dis.readLine();
		if (portType.equals("o")) {
		    if (! tmp.outport[portNo]) {
		  	tmp.outport[portNo] = true;
			tmp.outputs ++;
		     }
		    Func fouttmp = null, outtmp = null;
		    if (commStatus.equals("0")) { 
			fouttmp = fouts_head;
			while (fouttmp != null) {
			    if (fouttmp.abbrev.equals(fileName))
				break;
			    fouttmp = fouttmp.next;
			  }
			if (fouttmp == null) { 
			    outtmp = new Func("OutputFile", 100, 100, 1, 0);
			    outtmp.abbrev = fileName;
			    outtmp.next = fouts_head;
			    fouts_head  = outtmp;
			    outtmp.id   = foutputs;
		            outtmp.ilinks[1][0] = task_no;
		            outtmp.ilinks[1][1] = portNo;
			    foutputs ++;
			 }
		     }
		 }	
		else {
		    tmp.inputs ++;
		    Func fintmp = null, intmp = null;
		    if (commStatus.equals("0")) { 
		   	fintmp = fins_head; 
			while (fintmp != null) {
			    if (fintmp.abbrev.equals(fileName))
				break;	
			    fintmp = fintmp.next;
			  }
			if (fintmp == null) { 
			    intmp  = new Func("InputFile", 100, 100, 0, 1);
			    intmp.abbrev = fileName;
			    intmp.next   = fins_head;
			    fins_head    = intmp;
			    intmp.id     = finputs;
			    finputs ++;
			 }
		        tmp.ilinks[portNo][0] = (-1) *(finputs - 1);
		        tmp.ilinks[portNo][1] = 1;
		     }
		    else { 	
		        tmp.ilinks[portNo][0] = linkTaskNo;
		        tmp.ilinks[portNo][1] = linkPortNo;
		     }
		 }	
	   }		

	 while ((aline = dis.readLine()) != null) {
	    if (aline.equals("OFILE"))
		break;
	    System.out.println("I=" + aline);
	    tmp = fins_head;	
	    while ( tmp != null) {
		if (tmp.abbrev.equals(aline)) {
		    tmp.x = Integer.parseInt(dis.readLine());
		    tmp.y = Integer.parseInt(dis.readLine());
		    break;
		 }
		tmp = tmp.next;
	     }
	  }
	 while ((aline = dis.readLine()) != null) {
	    tmp = fouts_head;
	    while (tmp != null) {
		if (tmp.abbrev.equals(aline)) {
		    tmp.x = Integer.parseInt(dis.readLine());
		    tmp.y = Integer.parseInt(dis.readLine());
		    break;
		 }
		tmp = tmp.next;
	     }
	  }
         dis.close();
     } catch (IOException e1) {}
    modules ++;
    repaint();
  }
/* ************************************************************************* *
 *                       private run_app() for RunApp menu.
 *     inform master CVM to invoke acl, dvm and do corresponding processes
 *     by making the request to Java Server servlet runAppServ.
 * ************************************************************************* */
 
	private void run_app() {
 
		URL u2 = null;
		DataInputStream Fcvmtest = null;
		String aline;
 
/**
// added by B.Ye Jan/6th/98
		URL u_reset = null;
		URLConnection conJava;
		InputStream rawInput;

		System.out.println("\n run_app() in vdceapp resetting serv_stop file..."); 
		System.out.println("ACSHost : " + ACSServHost);
		System.out.println("uname : " + uname);

    try {
       String str = "http://" + JevServHost + ":" + PortNo +
                    "/servlet/reset_stop_Serv?userID=" + userID +
                    "&applID=" + applID;
	System.out.println("URL : " + str);
       u_reset = new URL(str);
     } catch (MalformedURLException e1) { }
        try {
             conJava = u_reset.openConnection();
             rawInput = conJava.getInputStream();
             DataInputStream DataIn = new DataInputStream(rawInput);
         } catch(IOException e) {
             System.out.println("an IO error has been raised. Error : " + e);
            }
**/

		/****** added to reset "serv_stop" file ****/

		System.out.println("\n  Inform server ACS to run the app...\n");
		String cvm_addr=null;
		String cvm_arg=null;
		String AES_addr=null;
		String AESServHost = null;
		String AESPortNo = null;

		AESServHost = JevServHost;
		AESPortNo = PortNo;

		cvm_addr = "http://" + ACSServHost + ":" + ACSPortNo
				+ "/servlet/cvm3";

		cvm_arg 	= "&userID="		+ userID 
				+ "&applID="		+ applID
				+ "&AESServHost="	+ AESServHost
				+ "&AESPortNo="		+ AESPortNo
				+ "&DrepIP="		+ DrepIP
				+ "&DrepPort="		+ DrepPort
				+ "&DrepDBA="		+ DrepDBA; 

		String str = "http://" + JevServHost + ":" + PortNo
				+ "/servlet/execTimeServ"
				+ "?userID="	+userID 
				+ "&applID="	+ applID
				+ "&DrepIP="	+ DrepIP
				+ "&DrepPort="	+ DrepPort
				+ "&DrepDBA="	+ DrepDBA;
 
		Func funcs = funcs_head;
		int totalNum = 0;
		while (funcs != null) {
			totalNum ++;
			funcs = funcs.next;
		}
//		runwin = new RunWin(this, totalNum, u2, str); 
//		runwin = new RunWin(this, totalNum, cvm_addr, str);
		System.out.println("vdceapp : " + cvm_addr);
		System.out.println("vdceapp : " + cvm_arg);
		runwin = new RunWin(this, totalNum, cvm_addr, cvm_arg, 
			str, AESServHost, AESPortNo, uname);
	} // The End of run_app().

/* ************************************************************************* *
 *                       private stop_app() for StopApp menu.
 *     inform master CVM to stop corresponding processes
 *     by making the request to Java Server servlet stopAppServ.
 * ************************************************************************* */
 
  private void stop_app() {
 
    URL u2 = null;
    DataInputStream Fcvmtest = null;
    String aline;
 
    System.out.println("\n  Inform master CVM to stop the app...\n");
 
    try {
/**
       String str = "http://" + ACSServHost + ":" + ACSPortNo +
		    "/servlet/stopAppServ?userID=" + userID +
		    "&applID=" + applID + "&DB_IP=" +  DrepIP + 
                    "&DB_port=" + DrepPort;   // B.Ye, Jan./22nd/98
**/

       String str = "http://" + 
			JevServHost + ":" + PortNo +
			"/servlet/STOPproxy" +
			"?userID=" + userID +
			"&applID=" + applID + 
			"&DB_IP=" +  DrepIP + 
			"&DB_port=" + DrepPort +
			"&DB_ADMIN=" + DrepDBA +
			"&ACSServHost=" + ACSServHost +
			"&ACSPortNo=" + ACSPortNo;

       System.out.println(str);
       u2 = new URL(str);
     } catch (MalformedURLException e1) {}
 
    stopwin = new StopAppWin(this, u2); 
  }     // The End of stop_app().
 
/* ************************************************************************* *
 *                   private show_result() for ShowResult menu.
 * ************************************************************************* */
 
  private void show_result(String modu, int modu_no) {

    URL u3 = null;
//    DataInputStream result = null;
    BufferedReader result = null;
    String aline;
    String title = null;
 
    System.out.println("\n  The Computation Result of this Module : \n");
    try {
	 String str = currApplet.getParameter("FilePathURL");
	 System.out.println("FilePathURL=" + str);
	 if (modu_no == -1) { 
	     str = str + "/demo/bin/" + modu;
	     title = "File " + modu + "'s Contents";
	  }
	 else {
             str = str + "/demo/src/" + modu + ".c";
	     title = "Module " + modu + "'s Source";
	  }
         u3 = new URL(str);
     } catch (MalformedURLException e1) {
              System.out.println(" the output File doesn't exist."); }
    try {
//         result = new DataInputStream(u3.openStream());
         result = new BufferedReader( new InputStreamReader(u3.openStream()));
     } catch (IOException e1) {}
    new DataWin(title, result);
    System.out.println("  The End of Output.\n");
  } 	// The End of show_result().
 


/* ************************************************************************* *
 *  display_map() -- Display battle map
 * ************************************************************************* */
 private void Display_map() {

                 selected = false;

                 System.out.println("in Displaymap() function..");
                 /*****
                 civ_map f = new civ_map(currApplet);
                 f.resize(800,500);
                 f.show();
                 *****/

                 Frame display = new show_result(
					this, currApplet, 
					JevServHost, PortNo,
					ACSServHost, ACSPortNo,
					userID, applID,
					DrepIP, DrepPort);

                 //Applet f = new GIS();
                 display.resize(810,510);
                 display.show();
                 //hide_current_page();
                 /***
               try {
                URL display = new URL("http://" + JevServHost + ":" + PortNo
                                      + "/ver1/ADL/gis.html");
                Applet.getAppletContext().showDocument(display,_blank);
                   } catch(MalformedURLException e ) {
                     System.out.println("Unable to retrieve URL. Error : " +e );
                     }
                 ***/

 }

/* ************************************************************************ *
 *	 	private	InModule()
 * ************************************************************************* */

  private void InModule(Event e) {

    fins = fins_head;
    while (fins != null) {
        if ((new Rectangle(fins.x, fins.y,
             fins.width, fins.height)).inside(e.x, e.y)) {
             dragged = fins;
             if (e.modifiers == 8)    
                 show_result(fins.abbrev, -1);
             else
                dragging = true;
             break;
         }
        fins = fins.next;
     }
 
    fouts = fouts_head;
    while (fouts != null) {
        if ((new Rectangle(fouts.x, fouts.y,
             fouts.width, fouts.height)).inside(e.x, e.y)) {
             dragged = fouts;
             if (e.modifiers == 8) {   
                if ((! neverrun) && (! run)) {
		   System.out.println("neverrun=" + neverrun + " run=" + run);
                   show_result(fouts.abbrev, -1);
	 	 }
                else {
		  if (run) {
                     System.out.println("The application is running and has not finished.");
                     new MessageDia(this, "The application is running and has not finished.", false);
		   } 
		  else {
                     System.out.println(" you should run the application first.");
                     new MessageDia(this, "You should run the application first! ", false);
		   }
                 }
              } else
                dragging = true;
             break;
         }
        fouts = fouts.next;
     }
    funcs = funcs_head;
    while (funcs != null) {
        if ((new Rectangle(funcs.x, funcs.y,
             funcs.width, funcs.height)).inside(e.x, e.y)) {
             dragged = funcs;   

             if (e.modifiers == 4)   // right button, B.Ye
             {     
                     /***
                     if( (funcs.name).startsWith("Display") )  // B.Ye
                        Display_map();      // display battle map
                     else  ***/
	             if (funcs.prefdia == null) {
                     System.out.println("information from saved DB:"); //B.Ye
                     System.out.println("sequential:" + funcs.sequential);
                     System.out.println("platForm:" + funcs.platForm);
                     System.out.println("threadType:" + funcs.threadType);
                     System.out.println("Protocol:" + funcs.Protocol);
                     System.out.println("qosvalue:" + funcs.qosvalue);
                     System.out.println("machnum:" + funcs.machnum); // B.Ye
                     System.out.println("machnum[0]:" + funcs.machnum[0]); // B.Ye

                     funcs.prefdia = new RunPrefDialog(this, funcs, "Module Running Preference");
                     }
                     else  funcs.prefdia.show(true);
              } // right button 

             else if (e.modifiers == 8) {    // middle button, B.Ye 
                 show_result(funcs.name, funcs.id);
              } else
                 dragging = true;
             break;
          }             
        funcs = funcs.next;
     }                  // while loop
} 

/* ************************************************************************* *
 *                   private AddLink() for MOUSE_DOWN event processing.
 * ************************************************************************* */
 
  private void AddLink(Event e) {

    if (addlink) {      
        fins = fins_head;
        while (fins != null) {
            int step = fins.width / 2;
            if ((new Rectangle(fins.x + step,
                 fins.y + fins.height-10, 10, 10)).inside(e.x, e.y)) {
                 linkable = true;
                 linkfrom = (-1) * fins.id;
                 linkport = 1;   
                 break;
             }          
            fins = fins.next;
          }             
     }                  
 
    if (addlink) {      
        funcs = funcs_head;
        while (funcs != null) {
            int step = funcs.width / (funcs.outputs+1);
            for ( int j = 1; j <= funcs.outputs; j ++)
            if ((new Rectangle(funcs.x + step*j,
                 funcs.y + funcs.height-10, 10, 10)).inside(e.x, e.y)) {
                linkable = true;
                linkfrom = funcs.id;
                linkport = j;   
                break;
             }
            funcs = funcs.next;
         }    // while loop
      }       // if addlink
 
    if (linkable) {   
        fouts = fouts_head;
        while (fouts != null) {
            int step = fouts.width / 2;
            if ((new Rectangle(fouts.x + step,
                 fouts.y, 10, 10)).inside(e.x, e.y)) {
 
     //      if (i != linkfrom) {    
 
                 if (linkfrom > 0) {
                     linkable = false;
                     currModu = fouts.id;
                     linkto   = 1;       
                     register = true;    
                     outf = true;
                     break;
                  }
             }  
            fouts = fouts.next;
         }      
     }          // if linkable
 
    if (linkable) {     
        funcs = funcs_head;
        while (funcs != null) {
            int step = funcs.width / (funcs.inputs + 1);
            for (int j = 1; j <= funcs.inputs; j ++)
              if ((new Rectangle(funcs.x + step*j,
                   funcs.y, 10, 10)).inside(e.x, e.y)) {
                   if (funcs.id != linkfrom) {
                       linkable = false;
                       currModu = funcs.id;
                       linkto   = j;    
                       register = true; 
                       break;
                    }
               }
            funcs = funcs.next;
         }      // while loop
     }          // if linkable
 
}
 
/* ************************************************************************* *
 *                   private RmLink() for MOUSE_DOWN event processing.
 * ************************************************************************* */

  private void RmLink(Event e) {
 
    if (rmlink) {       
        fins = fins_head;
        while (fins != null) {
            int step = fins.width / 2;
            boolean inport = false;
            if ((new Rectangle(fins.x + step,
                 fins.y + fins.height-10, 10, 10)).inside(e.x, e.y)) {
                 inport = true;
                 funcs = funcs_head;    
                 while (funcs != null) {
                     for (int i = 1; i <= funcs.inputs; i ++)
                          if (funcs.ilinks[i][0] == (-1) * fins.id) {
                              funcs.ilinks[i][0] = 0;
                              funcs.ilinks[i][1] = 0;
                           }
                     funcs = funcs.next;
                  }
             }          	
            if (inport) break;  
            fins = fins.next;
          }             	
        fouts = fouts_head;
        while (fouts != null) { 
            int step = fouts.width / 2;
            boolean inport = false;
            if ((new Rectangle(fouts.x + step,
                 fouts.y, 10, 10)).inside(e.x, e.y)) {
                 inport = true;
                 funcs = funcs_head;    
                 while (funcs != null) {
                     boolean found = false;
                     for (int i = 1; i <= funcs.outputs; i ++)
                          if ((fouts.ilinks[1][0] == funcs.id) &&
                              (fouts.ilinks[1][1] == i)) {
                                found = true;
                                fouts.ilinks[1][0] = 0;
                                fouts.ilinks[1][1] = 0;
                                break;
                           }
                     if (found) break;
                     funcs = funcs.next;
                  }
             }          
            if (inport) break;
            fouts = fouts.next;
          }             
        funcs = funcs_head;
        while (funcs != null) { 
 
            int step = funcs.width / (funcs.outputs+1);
            for ( int j = 1; j <= funcs.outputs; j ++)
            if ((new Rectangle(funcs.x + step*j,
                 funcs.y + funcs.height-10, 10, 10)).inside(e.x, e.y)) {
                 fouts = fouts_head;
                 while (fouts != null) {
                    if ((fouts.ilinks[1][0] == funcs.id) &&
                        (fouts.ilinks[1][1] == j)) {
                         fouts.ilinks[1][0] = 0;
                         fouts.ilinks[1][1] = 0;
                      }
                    fouts = fouts.next;
                  }
                Func funcst = funcs_head;
                while (funcst != null) {
                   for (int i = 1; i <= funcst.inputs; i ++)
                        if ((funcst.ilinks[i][0] == funcs.id) &&
                            (funcst.ilinks[i][1] == j)) {
                             funcst.ilinks[i][0] = 0;
                             funcst.ilinks[i][1] = 0;
                         }
                   funcst = funcst.next;
                 }
             }  
 
            boolean found = false;
            step = funcs.width / (funcs.inputs + 1);
            for (int j = 1; j <= funcs.inputs; j ++)
              if ((new Rectangle(funcs.x + step*j,
                   funcs.y, 10, 10)).inside(e.x, e.y)) {
                   fins = fins_head;
                   while (fins != null) {
                      if (funcs.ilinks[j][0] == (-1)*fins.id) {
                          funcs.ilinks[j][0] = 0;
                          funcs.ilinks[j][1] = 0;
                          found = true;
                          break;
                       }
                      fins = fins.next;
                    }
                   Func funcst = funcs_head;
                   while ((funcst != null) && (! found)) {
                      for (int i = 1; i <= funcst.outputs; i ++)
                           if ((funcs.ilinks[j][0] == funcst.id) &&
                               (funcs.ilinks[j][1] == i )) {
                                funcs.ilinks[j][0] = 0;
                                funcs.ilinks[j][1] = 0;
                                found = true;
                                break;
                            }
                      funcst = funcst.next;
                    }
                }       
            funcs = funcs.next;
         }    // while loop
     }                  // if rmlink
} 
 
/* ************************************************************************* *
 *             private DelModule() for MOUSE_DOWN event processing.
 * ************************************************************************* */
 
  private void DelModule(Event e) {

    if ((dragged != null)&& (delmodule)) {

	for (int i = 1; i <= dragged.outputs; i ++) {
             fouts = fouts_head;
             while (fouts != null) {
                if ((fouts.ilinks[1][0] == dragged.id)&&
		    (fouts.ilinks[1][1] == i)) {
                    fouts.ilinks[1][0] = 0;
                    fouts.ilinks[1][1] = 0;
                 }
                fouts = fouts.next;
              }
             Func funcst = funcs_head;
             while (funcst != null) {
                for (int j = 1; j <= funcst.inputs; j ++)
                     if (((funcst.ilinks[j][0] == dragged.id)||
			  (funcst.ilinks[j][0] == (-1)*dragged.id)) &&
                         (funcst.ilinks[j][1] == i )) {
                          funcst.ilinks[j][0] = 0;
                          funcst.ilinks[j][1] = 0;
                      }
                funcst = funcst.next;
	      }
	   }	// for this module's outport loop

	boolean found = false;
	if (dragged == fins_head) {
	    fins_head = dragged.next;
	    dragged = null;
	    found = true;
	 } else
	if (dragged == fouts_head) {
	    fouts_head = dragged.next;
	    dragged = null;
	    found = true;
	 } else
	if (dragged == funcs_head) {
	    funcs_head = dragged.next;
	    dragged = null;
	    found = true;
	 }
	if (!found) {		
	    fins = fins_head;
	    while (fins != null) {
	       if (fins.next == dragged) { 
	           fins.next = dragged.next;
	    	   dragged = null;
	           found = true;
	           break;
	        }
	       fins = fins.next;
	     }
	 }
	if (! found) {
	    fouts = fouts_head;
	    while (fouts != null) {
		if (fouts.next == dragged) {
		    fouts.next = dragged.next;
	    	    dragged = null;
		    found = true;
		    break;
		 }
		fouts = fouts.next;
	     }
	 }
	if (!found) {
	    funcs = funcs_head;
	    while (funcs != null) {	
	       if (funcs.next == dragged) {
		   funcs.next = dragged.next;
	    	   dragged = null;
		   found = true;
		   break;
	        }
	       funcs.next = dragged.next;
             }
         }
    if (dragged == null)
	dragging = false;
// =====paint()=====
    repaint();
     }
} 

/* ************************************************************************* *
 *             private mouse_dwn() for MOUSE_DOWN event processing.
 * ************************************************************************* */
 
  private void mouse_dwn(Event e) {

    if (selected)  {
        tmpf.move(e.x,e.y);
        ModuAdd(tmpf);
        setCursor(DEFAULT_CURSOR);
        selected = false;
        addlink  = false;	
	rmlink   = false;	
	delmodule= false;	
    }
 
    InModule(e);

    if (dragging) {
        tx = e.x - dragged.x; ty = e.y - dragged.y;
     }

    AddLink(e);

    RmLink(e);

    DelModule(e);

  }		// The End of mouse_dwn().

/* ************************************************************************ *
 * 
 * 		private mouse_up()	
 *
 * ************************************************************************ */

  private void mouse_up() {

        dragging = false;       // if dragging
 
        if (register) {
            saved = false;      
            run   = false;
            if (outf) {
                fouts = fouts_head;
                while (fouts != null) {
                    if (fouts.id == currModu) {
                        fouts.ilinks[linkto][0] = linkfrom;
                        fouts.ilinks[linkto][1] = linkport;
                        outf = false;
                        break;
                     }
                    fouts = fouts.next;
                 }
             } else {
                funcs = funcs_head;
                while (funcs != null) {
                    if (funcs.id == currModu) {
                        funcs.ilinks[linkto][0] = linkfrom;
                        funcs.ilinks[linkto][1] = linkport;
                        break;
                     }
                    funcs = funcs.next;
                 }
             }
            register = false;
            repaint();
        }
}
/* ************************************************************************ *
 * 
 * 	All event processes 
 *
 * ************************************************************************ */

  public boolean handleEvent(Event e) { 

    switch (e.id) {
    case Event.ACTION_EVENT:
      if (e.target instanceof vMenuItem) {
	  setCursor(CROSSHAIR_CURSOR);
	  String selection = ((vMenuItem)(e.target)).getLabel();

	  if (selection.equals("Open")) {
	      setCursor(DEFAULT_CURSOR);
	      openOrnew = 1;	// July 25
              if ((! saved) && ((funcs_head != null)||
                 (fins_head != null)||(fouts_head != null))) {
//                 System.out.println("You did something but didn't save it yet.")
                 System.out.println("Quit Without Savng?")
;
//		 openOrnew = 1;	// July 25
                 discard = new MessageDia(this, "Do You Want to quit without saving? ", true);
               }
              if ( discard == null) {
                   saved      = false;
                   fins_head  = null;
                   fouts_head = null;
                   funcs_head = null;
	           open_appl();
               }
	   }
	  else if (selection.equals("New")) {
              civapp = false;   // B.Ye, may/5th/98, true-running civapp, otherwise linear
	      openOrnew = 2;	// July 25
              if ((! saved) && ((funcs_head != null)||
                 (fins_head != null)||(fouts_head != null))) {
                 System.out.println("You did something but didn't save it yet.");
//		 openOrnew = 2;	// July 25
                 discard = new MessageDia(this, "Quit current application withour Saving? ", true);
               }
//	      if ( ((discard != null)&&(discard.ok)) || (discard == null)) {
	      if ( discard == null) {
        	   saved      = false;
        	   fins_head  = null;
        	   fouts_head = null;
        	   funcs_head = null;
                   fnd = new FileNmDialog(this, "Input Application Name : ");
	           newappl = true;
               }
	      setCursor(DEFAULT_CURSOR);
	   }

	  else if (selection.equals("Save As")) {
	      setCursor(DEFAULT_CURSOR);
	      System.out.println("Save As");}

          else if (selection.equals("Add Link")) { 
   	        addlink = true;
        	selected = false;	
		rmlink   = false;	
		delmodule= false;	
	    }

	  else if (selection.equals("Remove Link")) { 
	      rmlink   = true;
   	      addlink  = false; 
              selected = false;	
	      delmodule= false;	
	    }

	  else if (selection.equals("Delete Modu")) { 
	      delmodule = true;
	      rmlink    = false; 
   	      addlink   = false; 
              selected  = false; 
	    }

	  else if (selection.equals("Save")) {
		if (run)
		    new MessageDia(this, "Your Application Is Running...", false);
		else if ((fins_head == null) && (fouts_head == null)
		    && (funcs_head == null)) {
		    System.out.println("Nothing to Save...");
//		    new MessageDia(this, "You didn't do anything nearly.", false);
		    new MessageDia(this, "Nothing to Save.", false);
		 } else {
		    if (applName == null) {
              	        fnd = new FileNmDialog(this, "Input Application Name : ");
                  	newappl  = true;
			openOrnew = 2;	
			saveflag = true;
		     }
		    else {
		        save();
		        saved = true;
			saveflag  = false;
		        exitflag  = null;
		        run   = false;
			neverrun = true;	
		     }
		 }
	        setCursor(DEFAULT_CURSOR);
             }	// End of "Save".

          else if (selection.equals("Exit")) {
	       if (run) {
		  new MessageDia(this, 
			"Your Application Is Running...Stop It First.", false);
		}
	       else if ((! saved) && ((funcs_head != null)||
		   (fins_head != null)||(fouts_head != null))) {
		    System.out.println("You did something but didn't save it yet.");
//		    exitflag = new MessageDia(this, "You did something but didn't save it yet.\n Still Want to Exit ? ", true);
		    exitflag = new MessageDia(this, "Ecit Without Saving?  ", true);
		 }  
		if (exitflag == null) {
		    if (! run) {
		        currApplet.vdceexit = true;
		        this.dispose();
		        currApplet.vdce = null;
		     }
		 }
		else if (exitflag.ok == 1) {
		    currApplet.vdceexit = true;
		    this.dispose();
		    currApplet.vdce = null;
		 }
	        setCursor(DEFAULT_CURSOR);
	    }

          else  if (selection.equals("Run App")) {
		if (saved) { 
		    run = true;
// June.17 , comment following two lines just for cvm debugging
//		    savemenu.disable();
//		    run_appl.disable();	// now, just simply disable them,6/6/97 
		    startDate = new Date();
		    startTime = startDate.getTime();
		    neverrun  = false;	// June 27, setting it for time visualization
                    /***
                    if(civapp) 
                      Display_map();  // display the battle map
                    ****/
		    run_app();
		 }
		else {
		   System.out.println("  the app hasn't been saved.");
		   new MessageDia(this, "You should save the application first! ", false);
		}
	        setCursor(DEFAULT_CURSOR);
	    }
  
	  else  if (selection.equals("Stop App")) {
		System.out.println("The menu StopApp is clicked.");
		if (run) { 
		    System.out.println("The App is Running.");
		    stop_app(); // need to be modified to destroy servlets
		 }
		else {
		   System.out.println("  the application is not running now.");
		   new MessageDia(this, " The application is not running now! ", false);
		 }	
	        setCursor(DEFAULT_CURSOR);
	    }
          else  if (selection.equals("Execution Time")) {
		if (neverrun) {
		   System.out.println("  the application never runs yet.");
		   new MessageDia(this, " The application has not run yet! ", false);
		 }
		else {
		   eTimevisualWin = new TimeVisualWin(currApplet, this,  
			     JevServHost, PortNo, userID, applID, startTime,
			     DrepIP, DrepPort, DrepDBA);
		 }
	        setCursor(DEFAULT_CURSOR);
	     }

          else  if (selection.equals("Load Information")) {
		if (loadinfoWin == null) {
		    System.out.println("invoke the load visual window");
		    String urlstr = "http://" + JevServHost + ":" + PortNo 
			 	  + "/servlet/loadInfoServ";

// Oct. 10, for multi-domain supporting. add domain rep parameters
       urlstr = urlstr + "?DrepIP=" + DrepIP + "&DrepPort=" + DrepPort
	     + "&DrepDBA=" + DrepDBA;

		    loadinfoWin = new loadInfoWin(this, urlstr);
		 }
		else {
		    if (! loadinfoWin.isShowing())
			loadinfoWin.show();
		 }
	        setCursor(DEFAULT_CURSOR);
	     }

          else  if (selection.equals("Selected Machines")) {
		if (neverrun) {
		   System.out.println("  the application never runs yet.");
		   new MessageDia(this, " The application has not run yet! ", false);
		 }
		else {
		  System.out.println("before starting Selected Machine Visul...");
		  String urlstr = "http://" + JevServHost + ":" + PortNo 
		    + "/servlet/SelectedInfoServ";
		  urlstr = urlstr + "?userID=" + userID + "&applID=" + applID
		    + "&DrepIP=" + DrepIP + "&DrepPort=" + DrepPort
		    + "&DrepDBA=" + DrepDBA;

		  selectedinfowin = new selectedInfoWin(this, urlstr);

		  System.out.println("after starting Selected Machine Visual...");
		 }
	        setCursor(DEFAULT_CURSOR);
	  }

	  else  if (selection.equals("CIV Monitor")) { // B.Ye,March,31st
		if (neverrun) {
		   System.out.println("  the application has not runs yet.");
		   new MessageDia(this, " The application has not run yet! ", false);
		 } 
                 else {
                 selected = false;
                 Display_map();      // display civ map
                }

          }  // B.Ye , May, 6th

          else if (selection.equals("InputFile")) {

		fnd = new FileNmDialog(this, "Input File Name : ");
	        selected = true;
		finput = true;
                tmpf = new Func(selection, 100, 100, 0, 1);
	    }
          else if (selection.equals("OutputFile")) {

		fnd = new FileNmDialog(this, "Output File Name : ");
		selected = true;
	    	foutput = true;
                tmpf = new Func(selection, 100, 100, 1, 0);
	    }		
	  else { 	
	        selected = true;
		finput   = false;	// fix the bug Jan.21
		foutput  = false;	// fix the bug Jan.21
                tmpf = new Func(selection, 100, 100, ((vMenuItem)e.target).f.inputs, 
			((vMenuItem)e.target).f.outputs);
                if( selection.equals("Threat_Detection") ||
                    selection.equals("Fire_Control") ||
                    selection.equals("Display") )
                {  civapp = true; }
	        break;
	    }
        }	
       break;    //  case Event.ACTION_EVENT:

    case Event.MOUSE_MOVE:
       if (discard != null) {
          if (discard.ok == 1) {
              saved = false;
              fins_head = null;
              fouts_head = null;
              funcs_head = null;
              finputs  = 1;
              foutputs = 1;
              modules  = 1;
              if (openOrnew == 2) { 
	          System.out.println("discard in MOUSE_MOVE");
                  fnd = new FileNmDialog(this, "Input Application Name : ");
	       }
	      if (openOrnew == 1) { 
		  open_appl();
	       }
           }
	  if (discard.ok != 0)
	      discard = null;
        }
       if (openapp != null) {
           if (openapp.status == 1) {
               applName = openapp.applName;
	       neverrun = true;  
               load_appl();
	       System.out.println("after load_appl=**" + neverrun);
            }
	   if (openapp.status != 0)
               openapp = null;
        } 
       if ((fnd != null) && (openOrnew == 2) && (fnd.cancel)) 
	    applName = null;
       if ((fnd != null) && (openOrnew == 2) && (! fnd.cancel)) {
	   applName = fnd.tf.getText();
	   newappl  = false;	
	   openOrnew = 0; 	
	   if (saveflag)
	       getApplID(userID, applName, false);	
	   else {
	       getApplID(userID, applName, true);	
 	       if (applID.compareTo("0") == 0) {
	           new MessageDia(this, "The Name Already Exists. ", false);
	           applName = null;
	        }
	       else {
	           neverrun = true;  
		}
	    }

	   if ((saveflag) && (applID.compareTo("0") != 0)) {
	       System.out.println("in MOUSE_MOVE");
	       save();
	       neverrun = true;	
	       saved    = true;
	       saveflag = false;
	       exitflag = null;
	       run      = false;
 	    }
	   newappl  = false; 
	   fnd      = null;
        }
       break;
    case Event.MOUSE_DOWN:
       if (startup) 
 	   startup = false;		// when startup, show the welcome img
       mouse_dwn(e);
       repaint();
       break;
    case Event.MOUSE_DRAG:
       if (dragging) {
           dragged.move(e.x - tx, e.y - ty);
           repaint();
        }
       break;
    case Event.MOUSE_UP:
	mouse_up();
	if ((!addlink) && (!linkable) && (!rmlink) && (!delmodule))
	    setCursor(DEFAULT_CURSOR);
        break;

    }	// end of switch

    return super.handleEvent(e);

  }	

  private void getApplID(String userID, String applName, boolean flag) {

    URL u2 = null;
    DataInputStream applDis = null;
    String aline;
 
    System.out.println("\n  Request applServ to generate an applID...\n");
 
    try {
	String str = null;
	if (flag) {	// in new application
            str = "http://" + JevServHost + ":" + PortNo
                   + "/servlet/applServ1?userID=" + userID
                   + "&applName=" + applName;
	 }
	else {	// save
            str = "http://" + JevServHost + ":" + PortNo
                   + "/servlet/applServ?userID=" + userID
                   + "&applName=" + applName;
	 }

// Oct. 10, for multi-domain supporting. add domain rep parameters
       str = str + "&DrepIP=" + DrepIP + "&DrepPort=" + DrepPort
	     + "&DrepDBA=" + DrepDBA;

        u2 = new URL(str);
        System.out.println("URL=" + str + "##");
     }  catch (MalformedURLException e1) {}
    try {
        applDis = new DataInputStream(u2.openStream()); 
      } catch (IOException e1) {
           System.out.println("ERROR in: open ApplServ servlet stream");
         }

    try {
        while ((aline = applDis.readLine()) != null) {
	    applID = aline.trim();
            System.out.println("msg from applServ" + aline);
         }
        System.out.println("applID=" + applID);
        applDis.close();
      } catch (IOException e1) {}
  }

  void ModuAdd(Func module) {

    saved = false; 	
    run   = false;

    if ((finput)&& (!fnd.cancel)) {
	module.next = fins_head;
	fins_head   = module;
	module.id   = finputs;
        module.abbrev = fnd.tf.getText();
	finputs ++;
	finput = false;
     } else
    if ((foutput) && (!fnd.cancel)) {
	module.next = fouts_head;
	fouts_head  = module;
	module.id   = foutputs;
        module.abbrev = fnd.tf.getText();
	foutputs ++;
	foutput = false;
     } else {	
       if ((!finput) && (!foutput)) {
	    finput  = false;
	    foutput = false;
	    module.next = funcs_head;
	    funcs_head  = module;
	    module.id   = modules;
	    module.abbrev = null;
	    modules ++;
	}
     }
  }	// The End of ModuAdd().

  public void paint(Graphics g) {

    if ((finput) && (fnd.cancel)) {
	selected = false;
	finput   = false;
     }	
    if ((foutput) && (fnd.cancel)) {
	selected = false;
	foutput  = false;
     }
  //  g.setPaintMode();
        g.setColor(Color.black);

       if (discard != null) {
          if (discard.ok == 1) {
              saved = false;
              fins_head = null;
              fouts_head = null;
              funcs_head = null;
              finputs = 1;
              foutputs = 1;
              modules  = 1;
              if (openOrnew == 2) { 
	          System.out.println("discard in MOUSE_MOVE");
                  fnd = new FileNmDialog(this, "Input Application Name : ");
	       }
	      if (openOrnew == 1) { 
		  open_appl();
	       }
           }
	  if (discard.ok != 0)
	      discard = null;
        }
       if (openapp != null) {
           if (openapp.status == 1) {
               applName = openapp.applName;
               neverrun = true;  
               load_appl();
	       System.out.println("after load_appl=" + neverrun);
            }
	   if (openapp.status != 0)
               openapp = null;
        }

        if (exitflag != null)
        if (exitflag.ok == 1) { 
	    currApplet.vdceexit = true;
	    currApplet.vdce = null;
            this.dispose();
 	 } 

        if (dragged != null)
        if (dragged.prefdia != null) {
        if (dragged.prefdia.OkorNot) {
	    dragged.sequential = dragged.prefdia.sequential;
	    dragged.platForm   = dragged.prefdia.platForm;
	    dragged.threadType = dragged.prefdia.threadType;
	    dragged.Protocol   = dragged.prefdia.Protocol;
	    dragged.qosvalue   = dragged.prefdia.qosvalue;
	    dragged.machnum    = dragged.prefdia.machnum;
	    dragged.domain     = dragged.prefdia.domain;
	    dragged.cluster    = dragged.prefdia.cluster;
            System.out.println("\n  The Preference  : "); 
            System.out.println("Sequential: " + dragged.sequential);
            System.out.println("platForm=" + dragged.platForm);
            System.out.println("threadType=" + dragged.threadType);
            System.out.println("Protocol=" + dragged.Protocol);
            System.out.println("qosvalue=" + dragged.qosvalue);
            System.out.println("domain=" + dragged.domain);
            System.out.println("cluster=" + dragged.cluster);

            for (int i = 0; i < dragged.prefdia.machTypes.length; i ++)
            if (dragged.machnum[i] != null) {
                System.out.print("machine type:" + dragged.prefdia.machTypes[i]);
                System.out.println(" machine num:" + dragged.machnum[i]);
             }
	    dragged.prefdia.OkorNot = false;
	 }
	 }

        Func other_guy;
        funcs = funcs_head;
        while (funcs != null) {
           for (int i = 1 ; i <= funcs.inputs; i ++)  {
	     if (funcs.ilinks[i][0] != 0) {	// linked
	     if (funcs.ilinks[i][0] > 0) {
		 other_guy = funcs_head;
		 while (other_guy != null) {
		     if (other_guy.id == funcs.ilinks[i][0])
			 break;
		     other_guy = other_guy.next;
		  }
	      }
	     else {
		other_guy = fins_head;
		while (other_guy != null) {
		    if (other_guy.id == (-1) * funcs.ilinks[i][0]) 
			break;
		    other_guy = other_guy.next;
		 }
	      }	 
	     if (other_guy != null)
	         g.drawLine(other_guy.getx(false, funcs.ilinks[i][1]),
                   other_guy.gety(false), funcs.getx(true, i), funcs.gety(true));
	      }	
            }	
	    funcs = funcs.next;
        }		

        fouts = fouts_head;
        while (fouts != null) {
           for (int i = 1 ; i <= fouts.inputs; i ++)  {
	     if (fouts.ilinks[i][0] != 0) {	
	     if (fouts.ilinks[i][0] > 0) {
		 other_guy = funcs_head;
		 while (other_guy != null) {
		     if (other_guy.id == fouts.ilinks[i][0])
			 break;
		     other_guy = other_guy.next;
		  }
	      }
	     else { 
		other_guy = fins_head;
		while (other_guy != null) {
		    if (other_guy.id == (-1) * fouts.ilinks[i][0]) 
			break;
		    other_guy = other_guy.next;
		 }
	      }

	     g.drawLine(other_guy.getx(false, fouts.ilinks[i][1]),
               other_guy.gety(false), fouts.getx(true, i), fouts.gety(true));
	     }	
            }
	    fouts = fouts.next;
        }

        funcs = funcs_head;
        while (funcs != null ) {
	    funcs.paint(g);
	    funcs = funcs.next;
         }
        fins = fins_head;
        while (fins != null ) {
	    fins.paint(g);
	    fins = fins.next;
         }
        fouts = fouts_head;
        while (fouts != null ) {
	    fouts.paint(g);
	    fouts = fouts.next;
         }
  }	// The End of paint().

}	// The End of Class vdceapp.
