/********************************************************************
 *
 *	CIV_serlvet.java
 *		get the data from the application servlet 
 *		through the socket, and send the data to
 *		the civ applet.
 *		In socket connection to the Display module,
 *		CIV_servlet.java is a server.
 *
 *	Type : servlet
 *
 *	Author : Dongmin Kim
 *  
 *	Modifying History:
 *		June/9/98 by Dongmin Kim
 *
 ********************************************************************/

import java.net.*;
import java.io.*;
import javax.servlet.*;
 
public class CIV_servlet extends GenericServlet {

	// socket variables
	public static ServerSocket listen_socket = null;  
	public static Socket client;

	public static int	port = 16005;
	public static DataInputStream	in_stream = null;


	int	buf_size = 100;

	static PrintWriter out = null;  // outstream to applet

	FileOutputStream f_out = null;
	PrintStream ff1 = null ;
 
	/* Initial Values */
	public static 	int	NUM_AC = 4;		/* number of AC    */
	public static 	int	NUM_RADAR = 10;		/* number of Radar */
	public static	int	NUM_AIRBASE = 2;	/* number of AIRBASE */
	public static	int	SpeedTimer = 1000;
	public static	double	maxrange = 100000;
	public static	double	minelevation = -90;

	public static double[][] radar_loc =
					{
						{-73.36, 45.30, 0}, /* MONTREAL */
						{-73.77, 40.63, 0}, /* NYC      */
						{-73.80, 42.74, 0}, /* ALBANY   */
						{-75.48, 43.22, 0}, /* ROME     */
						{-76.10, 43.11, 0}, /* SYRACUSE */
					};

	public static double[][] airbase_loc = 
					{
						{-74.57, 39.45, 0}, /* AC   */
						{-70.56, 41.74, 0}  /* OTIS */
					};

	public static double[][][] ac_loc = {
						 { {-70.55, 41.15, 660,  0   },  
						   {-72.22, 41.09, 660,  515 }, /*disappear from here*/
						   {-72.24, 41.09, 90,   520 },
						   {-73.92, 40.75, 90,   720 },  /* NYC */
						   {-75.77, 44.05, 1000, 1800} }, /* Ft. Drum */

						 { {-78,    43.8,  10000, 10  },   /* BUFFALO  */  
						   {-73.94, 40.66, 10000, 1800},
						   {-72,    40,    10000, 2400}, 
						   {  0,     0,    0,      0  },
						   {  0,     0,    0,      0  } },

						 { {-71.02, 42.33, 5000,  5   }, /* BOSTON   */
						   {-73.80, 42.66, 5000,  1200}, /* ALBANY   */
						   {-78.86, 42.89, 5000,  2600}, /* BUFFALO  */ 
						   {  0,     0,    0,      0  },
						   {  0,     0,    0,      0  } } };

	public static int[] ac_leg = new int[NUM_AC];


	public void service(ServletRequest req, ServletResponse res)
			throws ServletException, IOException {

		int	i;

		System.out.println("In CIV_servlet..");
    
		out = new PrintWriter(res.getOutputStream());

		//****** save data to files *******
		try {
			f_out = new FileOutputStream("/tmp/show.log");
			ff1 = new PrintStream(f_out);
		}
		catch(IOException e) {
			System.out.println(e);
		}

		ff1.println("CIV servlet started");

		ff1.close();

		//--- fetch location information ----- 
		System.out.println("CIV app read the initial datus from table...");

		// make a socket connection
		set_socket_connection();

		initial_data();
		System.out.println("After Initial Data");

		frame_data();

		// close the socket connection
		close_socket_connection();

		System.out.println("End of Data!!");
	}
 
	public String getServletInfo() {
		return " servlet for getting computation data from Threat_target and Fire_controller modules ";
	}

       /*********************************************************
	*							*
	*	inital_data :
	*		read the initial data and send it.
	*							*
	*********************************************************/
	public void initial_data() {
		String init_str = null;
		// receive the data from the application
		try {
			init_str = in_stream.readLine();
		}
		catch(IOException e) {
			System.out.println("Read signal from Server error!");
		} 

		// send the data to the applet
		System.out.println("kimd:// data to be sent to the applet");
		System.out.println(init_str);
		out.println(init_str);
		out.flush();
	}

       /*********************************************************
	*							*
	*	body_data :
	*		read the data from the database and
	*		send to the applet
	*							*
	*********************************************************/
	public void frame_data() {
		boolean loop = true;
		String frame = null;

		while (loop) {

			// receive the data from the application
			try {
				frame = in_stream.readLine();
			}
			catch(IOException e) {
				System.out.println("Read signal from Server error!");
			} 

			// send the data to the applet
//			System.out.println(frame);
			System.out.println("Frame data");
			if ( frame == null ) {
				loop = false;
				System.out.println(frame);
				frame = "END";
				System.out.println("new : " + frame);
			}
			out.println(frame);
			out.flush();

		}
	}

       /*********************************************************
	*
	*	set_socket_connection :
	*		set the socket connection
	*
	*********************************************************/
	public void set_socket_connection() {
		try {
			listen_socket = new ServerSocket(port);
			if (listen_socket == null) {
				listen_socket = new ServerSocket(port);
			}
		}
		catch(IOException e) {
			System.out.println(e);
		}

		client = null;

		System.out.println("\n Server:" + port + " listening...");

		try {
			client = listen_socket.accept();
		} 
		catch (IOException ie) {
			System.out.println("Exception while listening for connections");
			ie.printStackTrace();
		} 
/**
		boolean loop = true;
		while ( loop ) {
			try {
				client = listen_socket.accept();
				loop = false;
			} 
			catch (IOException ie) {
				System.out.println("Exception while listening for connections");
				ie.printStackTrace();
			} 
		}
**/

		System.out.println("New connection from : " + client.getInetAddress());

		try {
			in_stream = new DataInputStream(client.getInputStream());
		}
		catch (IOException ioe) {
			System.out.println("IO Error when connect to Socket1");
			ioe.printStackTrace();
		}
	}

       /*********************************************************
	*
	*	close_socket_connection :
	*		close  databse connection
	*
	*********************************************************/
	public void close_socket_connection() {

		System.out.println("close the socket connection");

		try {
			in_stream.close();
			client.close();
			listen_socket.close();
			out.close();
		}
		catch (Exception e) {
			System.out.println(e);
		}
	}
}

