#include <stdio.h>
#include <math.h>

#include "p4.h"

#define DATA  1
#define DATA2 10

slave() {

  int master, type, from;
  int my_id;
  int i, j, k;
  int current_id, current_row;
  int nslave;
  int matrix_size, load;
  int int_size, float_size, size;
  int current_slave;
  int *incoming1;
  float **submatrix, *Base;
  float *incoming2;
  FILE  *fd;
  char  file_name[100];
  int   to;

  master = 0;

  my_id = p4_get_my_id();
  nslave = p4_num_total_ids() - 1;

#ifdef DEBUG
  sprintf( file_name, "/merlin2/users/demo/vdce/ver1/log/lu_slave%d.inter", my_id);
  fd = fopen(file_name, "w");
#endif
  
#ifdef DEMOLOG
  sprintf( file_name, "/merlin2/users/demo/vdce/ver1/log/lu_slave%d.inter", my_id);
  fd = fopen(file_name, "w");
#endif

#ifdef DEBUG
	fprintf(fd, "Slave : started\n");
	fflush(fd);
#endif

#ifdef DEMOLOG
	fprintf(fd, "Slave : started\n");
	fflush(fd);
#endif


  /* printf("Slave : %d\n", my_id); */
  /* receive load, matrix size, and data from Master */
  type = DATA;
  from = master;
  int_size = sizeof(int);

  incoming1 = NULL;
  p4_recv(&type, &from, &incoming1, &int_size);
  load = *incoming1;
  p4_msg_free(incoming1);

  incoming1 = NULL;
  p4_recv(&type, &from, &incoming1, &int_size);
  matrix_size = *incoming1;
  p4_msg_free(incoming1);

#ifdef DEBUG
	fprintf(fd, "Slave : recieved matrix size : %d   load : %d\n", matrix_size, load);
	fflush(fd);
#endif

#ifdef DEMOLOG
	fprintf(fd, "Slave : recieved matrix size : %d   load : %d\n", matrix_size, load);
	fflush(fd);
#endif

  
  submatrix = (float **) malloc(load * sizeof(float *));
  if (submatrix == NULL) {
        fprintf(fd, "malloc error at submatrix");
  }

  for ( i = 0 ; i < load ; i++ ) {
    submatrix[i] = (float *) malloc(matrix_size * sizeof(float));
  if (submatrix[i] == NULL) {
        fprintf(fd, "malloc error at submatrix[%d]",i);
  }

  }

  float_size = matrix_size * sizeof(float);
  for ( i = 0 ; i < load ; i++ ) {
    incoming2 = NULL;
    p4_recv(&type, &from, &incoming2, &float_size);
    for ( j = 0 ; j < matrix_size ; j++ ) {
      submatrix[i][j] = incoming2[j];
    }
    p4_msg_free(incoming2);
  }

  /* printf("Slave : %d\n", my_id); */

/*
  for ( i = 0 ; i < load ; i++ ) {
    for ( j = 0 ; j < matrix_size ; j++ ) {
      printf("%5.3f ", submatrix[i][j]);
    }
    printf("\n");
  }
*/

#ifdef DEBUG
	fprintf(fd, "Slave : data recieved done\n");
	fflush(fd);
#endif

#ifdef DEMOLOG
	fprintf(fd, "Slave : data recieved done\n");
	fflush(fd);
#endif

  /* k is the actual row number that is changed..
     current_slave is a slave number in which the row is changed.
     current_row is the row that is changed in each slave. */
  for ( k = 0 ; k < matrix_size - 1 ; k++ ) {
    current_slave = k % nslave + 1;
    current_row	= k / nslave;
    size = (matrix_size - k) * sizeof(float);

    /* broadcast all data from k to matrix_size - 1 on the row k */
    if ( my_id == current_slave ) {
      for ( to = 1 ; to <= nslave ; to++ ) {
	if ( to != my_id ) {
	  p4_send(DATA2, to, &submatrix[current_row][k], size);
	}
      }

      i    = current_row + 1;

      while ( i < load ) {
	submatrix[i][k]	= submatrix[i][k] / submatrix[current_row][k];
	j   = k + 1;
	while ( j < matrix_size ) {
	  submatrix[i][j] = submatrix[i][j] - submatrix[i][k] * submatrix[current_row][j];
	  j++;
	}
	i++;
      }
    }
    else { /* if my_id != current_slave */
      type = DATA2;
      from = current_slave;
      incoming2	= NULL;	
      p4_recv(&type, &from, &incoming2, &size);

      /* setup the Base array */
/*
      for ( i = k ; i < matrix_size ; i++ ) {
	Base[i] = incoming2[i - k];
      }
      p4_msg_free(incoming2);
*/
      for ( i = 0 ; i < load ; i++ ) {
	if ( i * nslave + my_id - 1 > k ) {
/*
	  submatrix[i][k]	= submatrix[i][k] / Base[k];
	  for ( j = k + 1 ; j < matrix_size ; j++ )
	    submatrix[i][j]	= submatrix[i][j] - submatrix[i][k] * Base[j];
*/
	  submatrix[i][k] = submatrix[i][k] / incoming2[0];
	  for ( j = k + 1 ; j < matrix_size ; j++ ) {
	    submatrix[i][j] = submatrix[i][j] - submatrix[i][k] * incoming2[j - k];
	  }
	}
      }
      p4_msg_free(incoming2);
    }
  }

#ifdef DEBUG
	fprintf(fd, "Slave : computation done\n");
	fflush(fd);
#endif

#ifdef DEMOLOG
	fprintf(fd, "Slave : computation done\n");
	fflush(fd);
#endif

  /* send the result matrix to the MASTER */
  for ( i = 0 ; i < load ; i++ ) {
    p4_send(DATA, master, submatrix[i], float_size);
  }
  free(submatrix);
  free(Base);

#ifdef DEBUG
  fprintf(fd, "Slave: done\n");
  fflush(fd);
   fclose(fd);
#endif

#ifdef DEMOLOG
  fprintf(fd, "Slave: done\n");
  fflush(fd);
   fclose(fd);
#endif


}
