#
#   Makefile for the Socket Send-Receive Test.
#

#
#	Macros
#

ARCH = Solaris
SRC      = server_acl.c
CC       = gcc
OPTIONS  = -DDEBUG 
CFLAGS	 = -O 
LDFLAGS	 = -lsocket -lnsl -lm
LDLIBS	 = -lmsql
TARGETS  = $(ARCH)/server_acl $(ARCH)/cluster_acl
mSQL_HOME_DIR = /merlin2/users/demo/vdce/mSQL/Solaris/Minerva
INCLUDEDIR = $(mSQL_HOME_DIR)/include
LIBDIR = $(mSQL_HOME_DIR)/lib

#
#	Dependencies
#

all: $(TARGETS)

$(ARCH)/server_acl: $(ARCH)/server_acl.o $(ARCH)/support.o $(ARCH)/timer.o
	$(CC) $(LDFLAGS) -o $(ARCH)/server_acl -L$(LIBDIR) -I$(INCLUDEDIR) $(CFLAGS) $(ARCH)/server_acl.o $(ARCH)/support.o $(ARCH)/timer.o $(LDLIBS)

$(ARCH)/cluster_acl: $(ARCH)/cluster_acl.o $(ARCH)/support.o $(ARCH)/timer.o
	$(CC) $(LDFLAGS) -o $(ARCH)/cluster_acl -L$(LIBDIR) -I$(INCLUDEDIR) $(CFLAGS) $(ARCH)/cluster_acl.o $(ARCH)/support.o $(ARCH)/timer.o $(LDLIBS)

$(ARCH)/server_acl.o : server_acl.c
	$(CC) -c -o $(ARCH)/server_acl.o -L$(LIBDIR) -I$(INCLUDEDIR) $(CFLAGS) server_acl.c

$(ARCH)/cluster_acl.o : cluster_acl.c
	$(CC) -c -o $(ARCH)/cluster_acl.o -L$(LIBDIR) -I$(INCLUDEDIR) $(CFLAGS) cluster_acl.c

$(ARCH)/support.o: support.c
	$(CC) $(CFLAGS) -c -o $(ARCH)/support.o support.c

$(ARCH)/timer.o: timer.c
	$(CC) $(CFLAGS) -c -o $(ARCH)/timer.o timer.c

clean:
	/bin/rm $(TARGETS) *.o
