//*****************************************************
//
//ACL_INV.java
//
// -- invoke acl and check the acl running ststus
//
// Modifying History :
// ===================
// 23rd,May,1997: invoke ACL and check ACL's running status
//
// 26th,June,1997: using socket to connect to ACL
//
//*****************************************************

import java.io.*;
import java.net.*;

public class ACL_INV {
  String acl_add = null ;
  String user_id = null ;
  String app_id = null ;
  int ACL_port = 50000;
  String aesServHost = null;
  ServerSocket serv = null ;
  Socket channel = null ;

 public ACL_INV(String acladd,String userid,String appid,int ACL_port_par,String AESServHost) {
  System.out.println("Ready to invoke ACL");
  acl_add = acladd;
  user_id = userid;
  app_id = appid ;
  ACL_port = ACL_port_par;
  aesServHost = AESServHost;

 /**
  System.out.println("user_id="+user_id);
  System.out.println("app_id="+app_id);
  **/
 }

 public int check() {

  int ret = 1 ;
  setup_conn_ACL();
  envoke_ACL();
  listen_ACL();
  ret = wait_ready();
  close_sock();

  return(ret);

 }

 //*** setup socket connection to ACL ****

 public void setup_conn_ACL() {
            try{
                serv = new ServerSocket(ACL_port);
                System.out.println("\n server cvm to ACL socket connection set up!");
             }
             catch(IOException e) {
                System.out.println("Exception when create server socket from server_cvm to ACL." + e );  }
 

 }

 //*** envoke ACL ****
 
 public void envoke_ACL() {

      System.out.println("ACL address : " + acl_add );
      try {
        Process p = Runtime.getRuntime().exec(acl_add);
      } catch(IOException e) {
        System.out.println("Exception when calling acl-inv!");
        e.printStackTrace();
        }
 }


 //**** listen to ACL ******
 public void listen_ACL() {

  System.out.println("Waiting for ACT and CIT table is ready ......");

   try{
       channel = serv.accept();
       System.out.println("\n server cvm listenning to information from the port " + ACL_port + " ...");
    } catch(IOException ie) { ie.printStackTrace();
                              System.out.println("fail when listenning to ACL.");
                             }
 
       System.out.println("New Connection from ACL : " + channel.getInetAddress()); 

 }


 //*** wait ACL signals

 public int wait_ready() {
   int ret = 1 ;

        try {
         String ACL_signal = null ;
         DataInputStream read_in = new DataInputStream(channel.getInputStream());

              while(true) {
               ACL_signal = read_in.readLine();
               if( (ACL_signal!=null)&&(ACL_signal.length()>50) )  {
                 System.out.println("signal from ACL :" + ACL_signal);
                 break;
               } //if
              } //while

              while(true) {
               ACL_signal = read_in.readLine();
                if(ACL_signal != null) {
                  if(ACL_signal.startsWith("1111")) {
                     ret = 1;
                     System.out.println("\n 1111 is received");
                  }
                  else { ret = -1 ;
                         System.out.println("Error report from ACL : " + ACL_signal);   }
                 break;
                } 
              } // while

            } catch(IOException e)
              { System.out.println("Error when receive information from ACL: " + e); 
              }

          return(ret);

 }
  

 //**** close socket connection between ACL ****
 public void close_sock() {
  
  try{
      channel.close();
      serv.close();
   } catch(IOException e) { System.out.println(e); }

  }

}

